/**
 * 行列折叠、锁定头和列功能更新说明：
 * 1、新增了变量
 * 2、修改的方法：
 * _parseChartForTable（未修改，待修改状态）
 * _createTable（已修改）
 * _cloneHeaderAndCol（新增）
 * mainTableOnScroll（新增）
 * divHeadScroll（新增）
 * divColScroll（新增）
 * _cloneHeaderTable（新增）
 * _cloneColTable（新增）
 * _removeColAndCrossTable（新增）
 * _cloneHeaderCrossTable（新增）
 * _parseHead（新增）
 * _appendHeadRow（已修改）
 * _appendDataRow（已修改）
 * _appendHeadCol（已修改）
 * _appendHeadEmptyCol（已修改）
 * _appendDataCol（已修改）
 * _appendDataEmptyCol（已修改）
 * 
 * _onClickFold（新增，需实现点击后的折叠请求）
 */

var Widgets = {};
var myWidget = [];
var myRowFilterArray = [];
var myMaskIsShow = [];
var myPlatform = true; //android===true  iOS===false
var myCell = [];
var myClickStatus = [];
var myHasRelation = [];

var myFirstColFieldKeys = [];
var myFirstGroupRowFieldKeys = [];
var supportGroupFold = false;
var myTableCellsWidth = [];
var myTableHeaderHeight = 0;
var myTableColWidth = 0;
var myTableHeight = 0;

var myTableCellsStatus = [];


/**
 * android
 * 创建表格类型的Widget
 */
Widgets.createTable = function(widget) {
    myWidget[widget.widget_id] = widget;
    var option = widget.options[0];
    myHasRelation[widget.widget_id] = _hasRelation(option);

    _parseTableWidget(widget);
}

/**
 * android
 * 创建空的内容
 */
Widgets.createEmptyTable = function() {
    var widgetChartBox = document.body;
    widgetChartBox.innerHTML = "<div></div>";
}

/**
 * android
 * 设置是否可以点击
 */
Widgets.setClickStatus = function(widgetId, clickStatus) {
    myClickStatus[widgetId] = clickStatus;
    _hideMask(widgetId, myCell[widgetId]);
}

//解析Table类型的Widget
function _parseTableWidget(widget) {
    //保存widget
    var tableValues = widget.values;
    var option = widget.options[0];

    //定义rowfilter的
    myRowFilterArray[widget.widget_id] = new Array(tableValues.length);

    var widgetChartBox = document.body;
    //支持列折叠，获取折叠列的fieldIds
    if (option.style !== undefined && option.style.group_fold === true) {
        supportGroupFold = true;
        if(option.chart !== undefined && option.chart.col_group_field !== undefined){
            var index = 0;
            for(var key in option.chart.col_group_field){
                 if(option.chart.col_group_field[key] !== undefined){
                    var col_field_value = option.chart.col_group_field[key];
                    myFirstColFieldKeys[index] = col_field_value.field_key;
                    index++;
                }
            }
        }

        if(option.chart !== undefined && option.chart.row_group_field !== undefined){
            var index = 0;
            for(var key in option.chart.row_group_field){
                 if(option.chart.row_group_field[key] !== undefined){
                    var row_field_value = option.chart.row_group_field[key];
                    myFirstGroupRowFieldKeys[index] = row_field_value.field_key;
                    index++;
                }
            }
        }
    }


    if (option.style !== undefined && option.style.group_col_lock === true) {
        // window.huoban.toast("_cloneHeaderAndCol21:" + widgetChartBox.innerHTML);
        var divStrArray = [];
        divStrArray.push("<div id=\"tableWidgetParent_" + widget.widget_id + "\" onscroll=\"mainTableOnScroll(" + widget.widget_id + ")\" class=\"parent_div\">");

        divStrArray.push("<div id=\"tableWidgetDiv_" + widget.widget_id + "\" class=\"table_main\" ><table id=\"tableWidget_" + widget.widget_id + "\" class=\"chart_tablelist align_center\"></table></div>");
        divStrArray.push("<div id=\"tableWidgetHeaderDiv_" + widget.widget_id + "\" class=\"table_header\"><table id=\"tableWidgetHeader_" + widget.widget_id + "\" class=\"chart_tablelist\"></table></div>");
        divStrArray.push("<div id=\"tableWidgetColDiv_" + widget.widget_id + "\"  class=\"table_col\"><table id=\"tableWidgetCol_" + widget.widget_id + "\" class=\"chart_tablelist\"></table></div>");
        divStrArray.push("<div id=\"tableWidgetCrossDiv_" + widget.widget_id + "\" class=\"table_cross\"><table id=\"tableWidgetCross_" + widget.widget_id + "\" class=\"chart_tablelist\"></table></div>");

        divStrArray.push("</div>");

        widgetChartBox.innerHTML = divStrArray.join('');
        _createTable(widget, tableValues, option);
        _cloneHeaderAndCol(widget.widget_id, tableValues, option);
    }else{
        var divStrArray = [];

        divStrArray.push("<div id=\"tableWidgetParent_" + widget.widget_id + "\" class=\"parent_div\">");
        divStrArray.push("<div id=\"tableWidgetDiv_" + widget.widget_id + "\" class=\"table_main\"><table id=\"tableWidget_" + widget.widget_id + "\" class=\"chart_tablelist\"></table></div>");
        divStrArray.push("</div>");

        widgetChartBox.innerHTML = divStrArray.join('');
        _createTable(widget, tableValues, option);
    }
}

/**
 * 创建full表格
 * @param {*} widget 
 * @param {*} tableValues 
 * @param {*} option 
 */
function _createTable(widget, tableValues, option){
    var tableStrArray = [];
    tableStrArray.push("<thead>");

    _parseHead(widget.widget_id, tableValues, tableStrArray, option, 0, false);

    tableStrArray.push("</thead>");

    tableStrArray.push("<tbody>");
    if (tableValues.data !== undefined && tableValues.data !== null && tableValues.data.length > 0) {
        for (var j = 0; j < tableValues.data.length; j++) {
            if (tableValues.data[j] !== undefined && tableValues.data[j] !== null) {
                _appendDataRow(widget.widget_id, tableValues.data[j], tableStrArray, option, j, false, false);
            }
        }
    }
    tableStrArray.push("</tbody>");
    document.getElementById("tableWidget_" + widget.widget_id).innerHTML = tableStrArray.join('');
}

//克隆表格头和列
function _cloneHeaderAndCol(widgetId, tableValues, option){
    var tableWidget = document.getElementById("tableWidget_" + widgetId);

    var headerRowNumber = 0;
    for(var i = 0; i < tableValues.head.length; i++){
        if("group_field_type" in tableValues.head[i][0]){
            headerRowNumber += 1;
        }
    }
    //获取table每个单元格的宽度
    myTableCellsWidth.length = 0;
    myTableHeaderHeight = 0;
    myTableHeight = 0;

    for(var i=0;i<tableWidget.rows.length;i++){
        myTableCellsWidth[i] = new Array();
        for(var j=0;j<tableWidget.rows[i].cells.length;j++){
            myTableCellsWidth[i][j] = new Array();
            myTableCellsWidth[i][j][0] = tableWidget.rows[i].cells[j].offsetWidth;
            myTableCellsWidth[i][j][1] = tableWidget.rows[i].cells[j].offsetHeight;
        }
        //获取header的高度
        if(i < headerRowNumber){
            myTableHeaderHeight += tableWidget.rows[i].cells[0].offsetHeight;
        }
        // myTableHeight += tableWidget.rows[i].cells[0].offsetHeight;
    }
    myTableHeight = document.getElementById("tableWidgetDiv_" + widgetId).offsetHeight;

    var windowWidth = document.body.offsetWidth;

    //获取列的宽度
    myTableColWidth = 0;
    var colNumber = 0;
    for (var i = 0; i < tableValues.head[0].length; i++) {
        if(!("group_field_type" in tableValues.head[0][i])){
            colNumber = i;
            break;
        }
    }

    for(var i=0;i<tableWidget.rows[0].cells.length;i++){
        if(i < colNumber){
            myTableColWidth += tableWidget.rows[0].cells[i].offsetWidth;
        }else{
            break;
        }
    }

    if(myTableColWidth !== 0){
        myTableColWidth += 8;
    }

    _cloneHeaderTable(widgetId, tableValues, option);

    if(myTableColWidth < ((windowWidth * 2) / 3)){
        _cloneColTable(widgetId, tableValues, option);
        _cloneHeaderCrossTable(widgetId, tableValues, option);
    }else{
        _removeColAndCrossTable(widgetId);
    }
}

var lastLeft = 0;
var lastTop = 0;
function mainTableOnScroll(widgetId){
    lastLeft = document.getElementById("tableWidgetParent_" + widgetId).scrollLeft;
    lastTop = document.getElementById("tableWidgetParent_" + widgetId).scrollTop;
    divHeadScroll(widgetId, lastLeft);
    divColScroll(widgetId, lastTop);
}

function divHeadScroll(widgetId, lastLeft){
    document.getElementById("tableWidgetHeaderDiv_" + widgetId).scrollLeft = lastLeft;
}

function divColScroll(widgetId, lastTop){
    document.getElementById("tableWidgetColDiv_" + widgetId).style.top = (lastTop * (-1)) + 'px';
}

//克隆表格头
function _cloneHeaderTable(widgetId, tableValues, option){
    var tableHeaderStrArray = [];
    tableHeaderStrArray.push("<thead>");
    _parseHead(widgetId, tableValues, tableHeaderStrArray, option, 0, true);

    tableHeaderStrArray.push("</thead>");

    tableHeaderStrArray.push("<tbody>");
    tableHeaderStrArray.push("</tbody>");

    document.getElementById("tableWidgetHeader_" + widgetId).innerHTML = tableHeaderStrArray.join('');
    document.getElementById("tableWidgetHeaderDiv_" + widgetId).style.height = myTableHeaderHeight + 'px';
}

//克隆表格列
function _cloneColTable(widgetId, tableValues, option){
    if(myTableColWidth != 0){
        var tableColStrArray = [];
        tableColStrArray.push("<thead>");
        _parseHead(widgetId, tableValues, tableColStrArray, option, 2, true);
        tableColStrArray.push("</thead>");
        tableColStrArray.push("<tbody>");
        if (tableValues.data !== undefined && tableValues.data.length > 0) {
            for (var j = 0; j < tableValues.data.length; j++) {
                _appendDataRow(widgetId, tableValues.data[j], tableColStrArray, option, j, true, true);
            }
        }
        tableColStrArray.push("</tbody>");
        document.getElementById("tableWidgetCol_" + widgetId).innerHTML = tableColStrArray.join('');
        document.getElementById("tableWidgetColDiv_" + widgetId).style.width = myTableColWidth + 'px';
        document.getElementById("tableWidgetColDiv_" + widgetId).style.height = myTableHeight + 'px';
    }else{
        var colDiv = document.getElementById("tableWidgetColDiv_" + widgetId);
        colDiv.parentNode.removeChild(colDiv);
    }
}

//移除列和Cross角
function _removeColAndCrossTable(widgetId){
    var colDiv = document.getElementById("tableWidgetColDiv_" + widgetId);
    colDiv.parentNode.removeChild(colDiv);

    var crossDiv = document.getElementById("tableWidgetCrossDiv_" + widgetId);
    crossDiv.parentNode.removeChild(crossDiv);
}

//克隆表格Cross
function _cloneHeaderCrossTable(widgetId, tableValues, option){
    if(myTableColWidth !== 0 && myTableHeaderHeight !== 0){
        var tableHeaderCrossStrArray = [];
        tableHeaderCrossStrArray.push("<thead>");
        _parseHead(widgetId, tableValues, tableHeaderCrossStrArray, option, 2, true);
    
        tableHeaderCrossStrArray.push("</thead>");
    
        tableHeaderCrossStrArray.push("<tbody>");
        tableHeaderCrossStrArray.push("</tbody>");
        document.getElementById("tableWidgetCross_" + widgetId).innerHTML = tableHeaderCrossStrArray.join('');
    
        document.getElementById("tableWidgetCrossDiv_" + widgetId).style.width = myTableColWidth + 'px';
        document.getElementById("tableWidgetCrossDiv_" + widgetId).style.height = myTableHeaderHeight + 'px';
    }else{
        var crossDiv = document.getElementById("tableWidgetCrossDiv_" + widgetId);
        crossDiv.parentNode.removeChild(crossDiv);
    }
}

function _parseHead(widgetId, tableValues, tableStrArray, option, headerType, isFixedWidth){
    if (tableValues.head !== undefined && tableValues.head !== null && tableValues.head.length > 0) {
        for (var i = 0; i < tableValues.head.length; i++) {
            if (tableValues.head[i] !== undefined && tableValues.head[i] !== null) {
                _appendHeadRow(widgetId, tableValues, tableStrArray, option, i, headerType, isFixedWidth);
            }
        }
    }
}


//增加头部的行 headerType 0 完整的header  1 右侧的header  2 重叠部分的header
function _appendHeadRow(widgetId, tableValues, tableStrArray, option, rowIndex, headerType,isFixedWidth) {
    if(tableValues.head[rowIndex] === undefined || tableValues.head[rowIndex] === null) return;

    tableStrArray.push("<tr>");
    for (var i = 0; i < tableValues.head[rowIndex].length; i++) {

        var foldType = 0;
        var isColFold = true;
        if (supportGroupFold) {
            // if("group_field_type" in tableValues.head[rowIndex][0]){
                var firstCellKey = tableValues.head[rowIndex][0].field_key;
                var currentCellKey = tableValues.head[rowIndex][i].field_key;

                if(i == 0 && myFirstColFieldKeys.indexOf(firstCellKey) > -1){
                    isColFold = true;
                    for (var j = 0; j < myFirstColFieldKeys.length; j++) {
                        if(tableValues.head[rowIndex][0].field_key === myFirstColFieldKeys[j]){
                            if (j < myFirstColFieldKeys.length - 1) {
                                if (rowIndex + 1 < tableValues.head.length ){
                                    if(myFirstColFieldKeys.indexOf(tableValues.head[rowIndex + 1][0].field_key) > -1){
                                        foldType = -1;
                                    }else{
                                        if(rowIndex < myFirstColFieldKeys.length - 1){
                                            foldType = 1;
                                        }
                                    }
                                }
                            }
                            break;
                        }
                    }
                }else if(myFirstGroupRowFieldKeys.indexOf(currentCellKey) > -1){
                    isColFold = false;
                    for (var j = 0; j < myFirstGroupRowFieldKeys.length; j++) {
                        if(tableValues.head[rowIndex][i].field_key === myFirstGroupRowFieldKeys[j]){
                            if (i < myFirstGroupRowFieldKeys.length - 1) {
                                if (i + 1 < tableValues.head[rowIndex].length ){
                                    if(myFirstGroupRowFieldKeys.indexOf(tableValues.head[rowIndex][i + 1].field_key) > -1){
                                        foldType = -1;
                                    }else{
                                        if(i < myFirstGroupRowFieldKeys.length - 1){
                                            foldType = 1;
                                        }
                                    }
                                }else{
                                    if(i < myFirstGroupRowFieldKeys.length - 1){
                                        foldType = 1;
                                    }
                                }
                            }
                            break;
                        }
                    }
                }
            // }
        }
        

        if(headerType === 0){
            _appendHeadCol(widgetId, tableValues.head[rowIndex][i], tableStrArray, rowIndex, i, isColFold, foldType, isFixedWidth);
        }else if(headerType === 1){
            if(!("group_field_type" in tableValues.head[rowIndex][i])){
                _appendHeadCol(widgetId, tableValues.head[rowIndex][i], tableStrArray, rowIndex, i, isColFold, foldType, isFixedWidth);
            }
        }else{
            if("group_field_type" in tableValues.head[rowIndex][i]){
                _appendHeadCol(widgetId, tableValues.head[rowIndex][i], tableStrArray, rowIndex, i, isColFold, foldType, isFixedWidth);
            }else{
                _appendHeadEmptyCol(widgetId, tableValues.head[rowIndex][i], tableStrArray, rowIndex, i, isColFold, foldType, isFixedWidth);
            }
        }
    }
    tableStrArray.push("</tr>");
}

//增加数据部分的行
function _appendDataRow(widgetId, rowData, tableStrArray, option, rowIndex, onlyCol, isFixedWidth) {
    var cellColor
    for (var i = 0; i < rowData.length; i++) {
        var fieldKey
        if (rowData[i].f !== undefined) {
            fieldKey = rowData[i].f;
        } else if (rowData[i].field_key !== undefined) {
            fieldKey = rowData[i].field_key;
        }

        cellColor = _isTotalRowStyle(fieldKey, rowData[i], option);
        if (cellColor !== undefined) {
            break
        }
    }

    tableStrArray.push("<tr>");

    var groupNumber = 0;
    for (i = 0; i < rowData.length; i++) {
        if (rowData[i].is_group !== undefined) {
            groupNumber += 1;
        } else {
            break;
        }
    }

    for (i = 0; i < rowData.length; i++) {
        if(!onlyCol){
            _appendDataCol(widgetId, rowData[i], tableStrArray, option, cellColor, rowIndex, i, groupNumber, isFixedWidth);
        }else{
            if("group_field_type" in rowData[i] || "is_total_stat" in rowData[i]){
                _appendDataCol(widgetId, rowData[i], tableStrArray, option, cellColor, rowIndex, i, groupNumber, isFixedWidth);
            }else{
                _appendDataEmptyCol(widgetId, rowData[i], tableStrArray, option, cellColor, rowIndex, i, groupNumber, isFixedWidth);
            }
        }
    }

    tableStrArray.push("</tr>");
}

//增加头部的单列
function _appendHeadCol(widgetId, colData, tableStrArray, rowIndex, colIndex, isColFold, foldType, isFixedWidth) {
        if(foldType === 0){
            tableStrArray.push("<th noWrap type=\"head\" onclick=\"_onClickHeader(" + widgetId + ")\"");
        }else if(foldType === 1){
            tableStrArray.push("<th noWrap type=\"head\" onclick=\"_onClickHeader(" + widgetId + ");_onClickFold(" + widgetId + "," + rowIndex + "," + colIndex + "," + isColFold + "," + foldType + ")\"");
        }else if(foldType === -1){
            tableStrArray.push("<th noWrap type=\"head\" onclick=\"_onClickHeader(" + widgetId + ");_onClickFold(" + widgetId + "," + rowIndex + "," + colIndex + "," + isColFold + "," + foldType + ")\"");
        }

        if(isFixedWidth){
            tableStrArray.push(" width=\"" + myTableCellsWidth[rowIndex][colIndex][0] + "px\"");
            tableStrArray.push(" height=\"" + myTableCellsWidth[rowIndex][colIndex][1] + "px\"");
        }

        if (colData.rowspan !== undefined) {
            tableStrArray.push(" rowspan=" + "\"" + colData.rowspan + "\"");
        }

        if (colData.colspan !== undefined) {
            tableStrArray.push(" colspan=" + "\"" + colData.colspan + "\"");
        }

        if(foldType === 0){
            tableStrArray.push("><span>");
        }else if(foldType == 1){
            tableStrArray.push("><span><i class=\"icon_jiahao\"></i>");
        }else if(foldType == -1){
            tableStrArray.push("><span><i class=\"icon_jianhao\"></i>");
        }

        if (colData.value !== undefined) {
            tableStrArray.push(colData.value);
        } else if (colData.v !== undefined) {
            tableStrArray.push(colData.v);
        } else {
            tableStrArray.push("--");
        }
        tableStrArray.push("</span></th>");
}

//增加空单元格，填补列复制的跨行问题
function _appendHeadEmptyCol(widgetId, colData, tableStrArray, rowIndex, colIndex, isColFold, foldType, isFixedWidth) {
    tableStrArray.push("<th noWrap type=\"head\"");

    if(isFixedWidth){
        tableStrArray.push(" width=\"" + 0 + "\"");
        tableStrArray.push(" height=\"" + myTableCellsWidth[rowIndex][colIndex][1] + "\"");
    }

    if (colData.rowspan !== undefined) {
        tableStrArray.push(" rowspan=" + "\"" + colData.rowspan + "\"");
    }

    if (colData.colspan !== undefined) {
        tableStrArray.push(" colspan=" + "\"" + colData.colspan + "\"");
    }

    tableStrArray.push("><span>");
    tableStrArray.push("");
    tableStrArray.push("</span></th>");
}


//增加表格数据内容的单列
function _appendDataCol(widgetId, colData, tableStrArray, option, cellColor, rowIndex, colIndex, groupNumber, isFixedWidth) {
    _setRowFilter(widgetId, colData, rowIndex);

    var isGroupField = false;
    var isDataField = true;
    if (colData.is_group !== undefined) {
        isGroupField = true;
        isDataField = false;
    }else if(colData.is_total_stat !== undefined){
        isDataField = false;
    }

    tableStrArray.push("<td type=\"data\" onclick=\"_onClickCell(this, event, " + isDataField + "," + widgetId + "," + isGroupField + "," + rowIndex + "," + (colIndex - groupNumber) + ")\"");

    if(isFixedWidth){
        var headRowNumber = 0;
        if(myWidget[widgetId] !== undefined && myWidget[widgetId].values !== undefined && myWidget[widgetId].values.head !== undefined){
            headRowNumber = myWidget[widgetId].values.head.length;
        }

        tableStrArray.push(" width=\"" + myTableCellsWidth[headRowNumber + rowIndex][colIndex][0] + "px\"");
        tableStrArray.push(" height=\"" + myTableCellsWidth[headRowNumber + rowIndex][colIndex][1] + "px\"");
    }

    if (colData.field_key !== undefined) {
        _setCellColor(colData.field_key, colData, tableStrArray, option, cellColor);
    } else if (colData.f !== undefined) {
        _setCellColor(colData.f, colData, tableStrArray, option, cellColor);
    }

    if (colData.rowspan !== undefined) {
        tableStrArray.push(" rowspan=" + "\"" + colData.rowspan + "\"");
    }

    if (colData.colspan !== undefined) {
        tableStrArray.push(" colspan=" + "\"" + colData.colspan + "\"");
    }


    if (colData.b !== undefined) {
        if (colData.a !== undefined) {
            var isShowOriValue = _isProgressBarShowOriValue(colData, option)
            if (isShowOriValue) {
                if (colData.a == 1) {
                    tableStrArray.push(" class=\"cell_left\"");
                } else if (colData.a == 2) {
                    tableStrArray.push(" class=\"cell_center\"");
                } else {
                    tableStrArray.push(" class=\"cell_right\"");
                }
            }
        }

        tableStrArray.push(">");

        _setProgressBarValue(colData, tableStrArray, option);

    } else {
        if (colData.a !== undefined) {
            if (colData.a == 1) {
                tableStrArray.push(" class=\"cell_left\"");
            } else if (colData.a == 2) {
                tableStrArray.push(" class=\"cell_center\"");
            } else {
                tableStrArray.push(" class=\"cell_right\"");
            }
        } else {
            tableStrArray.push(" class=\"cell_left\"");
        }

        tableStrArray.push(">");

        tableStrArray.push("<span>");

        if (colData.value !== undefined) {
            tableStrArray.push(colData.value);
        } else if (colData.v !== undefined) {
            tableStrArray.push(colData.v);
        } else {
            tableStrArray.push("--");
        }
        tableStrArray.push("</span>");
    }

    tableStrArray.push("</td>");
}


function _appendDataEmptyCol(widgetId, colData, tableStrArray, option, cellColor, rowIndex, colIndex, groupNumber, isFixedWidth) {
    tableStrArray.push("<td type=\"data\"");

    if(isFixedWidth){
        var headRowNumber = 0;
        if(myWidget[widgetId] !== undefined && myWidget[widgetId].values !== undefined && myWidget[widgetId].values.head !== undefined){
            headRowNumber = myWidget[widgetId].values.head.length;
        }

        tableStrArray.push(" width=\"" + 0 + "px\"");
        tableStrArray.push(" height=\"" + myTableCellsWidth[headRowNumber + rowIndex][colIndex][1] + "px\"");
    }

    if (colData.rowspan !== undefined) {
        tableStrArray.push(" rowspan=" + "\"" + colData.rowspan + "\"");
    }

    if (colData.colspan !== undefined) {
        tableStrArray.push(" colspan=" + "\"" + colData.colspan + "\"");
    }

    tableStrArray.push(">");
    tableStrArray.push("<span>");
    tableStrArray.push("");
    tableStrArray.push("</span>");

    tableStrArray.push("</td>");
}

//设置单元格的Option
function _setCellColor(fieldKey, colData, tableStrArray, option, cellColor) {
    var hasSetBackground = false;
    var hasSetFont = false;

    if (option.style !== undefined) {
        if (option.style.cell_color !== undefined) {
            for (var i = 0; i < option.style.cell_color.length; i++) {
                if (fieldKey == option.style.cell_color[i].field_key) {
                    if (option.style.cell_color[i].expression !== undefined) {
                        if (_inCondition(option.style.cell_color[i], colData) === false) {
                            continue;
                        } else {
                            if (option.style.cell_color[i].color !== undefined) {
                                if (option.style.cell_color[i].color.background !== undefined) {
                                    tableStrArray.push(" style=\"background-color:" + option.style.cell_color[i].color.background + ";");
                                    hasSetBackground = true;
                                }

                                if (option.style.cell_color[i].color.font !== undefined) {
                                    var hasCellColor1 = true;

                                    if (colData.b !== undefined) {
                                        var showType1 = _progressBarShowType(colData, option);
                                        if (showType1 !== undefined && showType1 == 1) {
                                            hasCellColor1 = false;
                                        }
                                    }

                                    if (hasCellColor1) {
                                        if (hasSetBackground) {
                                            tableStrArray.push("color:" + option.style.cell_color[i].color.font + ";");
                                        } else {
                                            tableStrArray.push(" style=\"color:" + option.style.cell_color[i].color.font + ";");
                                        }
                                        hasSetFont = true;
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
    }

    if (cellColor !== undefined && cellColor.color !== undefined) {
        if (colData.rowspan === undefined || colData.rowspan == 1) {
            //行设置背景色
            if (hasSetBackground === false && cellColor.color.background !== undefined) {
                if (hasSetBackground === true || hasSetFont === true) {
                    tableStrArray.push("background-color:" + cellColor.color.background + ";");
                } else {
                    tableStrArray.push(" style=\"background-color:" + cellColor.color.background + ";");
                }
                hasSetBackground = true;
            }
            //列设置字体色
            if (hasSetFont === false && cellColor.color.font !== undefined) {
                var hasCellColor2 = true;

                if (colData.b !== undefined) {
                    var showType2 = _progressBarShowType(colData, option);
                    if (showType2 !== undefined && showType2 == 1) {
                        hasCellColor2 = false;
                    }
                }

                if (hasCellColor2 === true) {
                    if (hasSetBackground === true || hasSetFont === true) {
                        tableStrArray.push("color:" + cellColor.color.font + ";");
                    } else {
                        tableStrArray.push(" style=\"color:" + cellColor.color.font + ";");
                    }
                    hasSetFont = true;
                }
            }
        }
    }

    if (hasSetBackground === true || hasSetFont === true) {
        tableStrArray.push("\"");
    }
}

//是否设置了整行样式
function _isTotalRowStyle(fieldKey, colData, option) {
    if (option.style !== undefined) {
        if (option.style.cell_color !== undefined) {
            for (var i = 0; i < option.style.cell_color.length; i++) {

                if (fieldKey == option.style.cell_color[i].field_key) {
                    if (option.style.cell_color[i].scope === undefined || option.style.cell_color[i].scope != "line") {
                        continue;
                    }
                    if (option.style.cell_color[i].expression !== undefined) {
                        if (_inCondition(option.style.cell_color[i], colData) === false) {
                            continue;
                        } else {
                            return option.style.cell_color[i];
                        }
                    }
                }
            }
        }
    }
}

//判断单元格的值是否在表达条件内
function _inCondition(cellColor, colData) {
    var value
    if (colData.t !== undefined && colData.t !== null) {
        value = colData.t;
    } else {
        return false;
    }

    if (colData.s === 0) {
        if (cellColor.sub_field_key === undefined || cellColor.sub_field_key === null) {

        } else {
            return false;
        }
    } else if (cellColor.sub_field_key !== undefined && cellColor.sub_field_key !== null) {
        if (colData.s === 1 &&
            cellColor.sub_field_key.key === "link_relative" &&
            cellColor.sub_field_key.value === "ori_value") {} else if (colData.s === 2 &&
            cellColor.sub_field_key.key === "link_relative" &&
            cellColor.sub_field_key.value === "incr_ratio") {} else if (colData.s === 3 &&
            cellColor.sub_field_key.key === "link_relative" &&
            cellColor.sub_field_key.value === "incr_value") {} else if (colData.s === 4 &&
            cellColor.sub_field_key.key === "year_basis" &&
            cellColor.sub_field_key.value === "ori_value") {} else if (colData.s === 5 &&
            cellColor.sub_field_key.key === "year_basis" &&
            cellColor.sub_field_key.value === "incr_ratio") {} else if (colData.s === 6 &&
            cellColor.sub_field_key.key === "year_basis" &&
            cellColor.sub_field_key.value === "incr_value") {} else if (colData.s === 7 &&
            cellColor.sub_field_key.key === "percent") {} else if (colData.s === 8 &&
            cellColor.sub_field_key.key === "rank" &&
            cellColor.sub_field_key.value === "total") {} else if (colData.s === 9 &&
            cellColor.sub_field_key.key === "rank" &&
            cellColor.sub_field_key.value === "group") {} else {
            return false;
        }
    } else {
        return false;
    }

    switch (cellColor.expression) {
        case 'eq':
            if (value == cellColor.value) {
                return true;
            }
            break
        case 'neq':
            if (value != cellColor.value) {
                return true;
            }
            break
        case 'gt':
            if (value > cellColor.value) {
                return true;
            }
            break
        case 'gte':
            if (value >= cellColor.value) {
                return true;
            }
            break
        case 'lt':
            if (value < cellColor.value) {
                return true;
            }
            break
        case 'lte':
            if (value <= cellColor.value) {
                return true;
            }
            break
        case 'range':
            if (value >= cellColor.value[0] && value <= cellColor.value[1]) {
                return true;
            }
            break
    }

    return false;
}

//进度条样式是否显示数值
function _isProgressBarShowOriValue(colData, option) {
    if (colData.b !== 0) {
        var progressBar = _getProgressBar(colData, option);
        if (progressBar !== undefined) {
            return progressBar.show_ori_value;
        }
    }
}

function _progressBarShowType(colData, option) {
    if (colData.b !== 0) {
        var progressBar = _getProgressBar(colData, option);
        if (progressBar !== undefined) {
            return progressBar.show_type;
        }
    }
}

//设置进度条的值
function _setProgressBarValue(colData, tableStrArray, option) {
    if (colData.b !== 0) {
        var progressBar = _getProgressBar(colData, option);
        if (progressBar !== undefined) {
            _setProgressBar(colData, tableStrArray, progressBar);
        }
    } else {
        tableStrArray.push("<span>");
        tableStrArray.push("--");
        tableStrArray.push("</span>");
    }
}

function _getProgressBar(colData, option) {
    var field_key
    if (colData.field_key !== undefined) {
        field_key = colData.field_key;
    } else if (colData.f !== undefined) {
        field_key = colData.f;
    }

    if (field_key !== null) {
        if (option.style !== undefined) {
            if (option.style.progress_bar !== undefined) {
                for (var i = 0; i < option.style.progress_bar.length; i++) {
                    var progressBar = option.style.progress_bar[i];
                    if (field_key === option.style.progress_bar[i].field_key) {
                        if (colData.s === 0) {
                            if (progressBar.sub_field_key === undefined || progressBar.sub_field_key === null) {
                                return progressBar;
                            }
                        } else if (progressBar.sub_field_key !== undefined && progressBar.sub_field_key !== null) {
                            if (colData.s === 1) {
                                if (progressBar.sub_field_key.key === "link_relative" &&
                                    progressBar.sub_field_key.value === "ori_value") {
                                    return progressBar;
                                }
                            } else if (colData.s === 2) {
                                if (progressBar.sub_field_key.key === "link_relative" &&
                                    progressBar.sub_field_key.value === "incr_ratio") {
                                    return progressBar;
                                }

                            } else if (colData.s === 3) {
                                if (progressBar.sub_field_key.key === "link_relative" &&
                                    progressBar.sub_field_key.value === "incr_value") {
                                    return progressBar;
                                }

                            } else if (colData.s === 4) {
                                if (progressBar.sub_field_key.key === "year_basis" &&
                                    progressBar.sub_field_key.value === "ori_value") {
                                    return progressBar;
                                }

                            } else if (colData.s === 5) {
                                if (progressBar.sub_field_key.key === "year_basis" &&
                                    progressBar.sub_field_key.value === "incr_ratio") {
                                    return progressBar;
                                }

                            } else if (colData.s === 6) {
                                if (progressBar.sub_field_key.key === "year_basis" &&
                                    progressBar.sub_field_key.value === "incr_value") {
                                    return progressBar;
                                }

                            } else if (colData.s === 7) {
                                if (progressBar.sub_field_key.key === "percent") {
                                    return progressBar;
                                }

                            } else if (colData.s === 8) {
                                if (progressBar.sub_field_key.key === "rank" &&
                                    progressBar.sub_field_key.value === "total") {
                                    return progressBar;
                                }
                            } else if (colData.s === 9) {
                                if (progressBar.sub_field_key.key === "rank" &&
                                    progressBar.sub_field_key.value === "group") {
                                    return progressBar;
                                }
                            }
                        }
                    }
                }
            }
        }
    }
}


function _setProgressBar(colData, tableStrArray, progressBar) {
    //底色模式
    if (progressBar.show_type == 1) {
        var value1
        if (colData.value !== undefined) {
            value1 = colData.value
        } else if (colData.v !== undefined) {
            value1 = colData.v
        }
        if (progressBar.show_ori_value === true) {
            tableStrArray.push(
                "<div class=\"table_progress_bg\">" +
                "<div class = \"progress_number\">" + value1 + "</div>" +
                "<div class=\"progress_bar\">" +
                "<div class=\"percent\" style=\"background-color:" +
                progressBar.color + "; width:" + colData.b * 100 + "%;\">" +
                "</div>" +
                "</div>" +
                "</div>");
        } else {
            tableStrArray.push(
                "<div class=\"table_progress_bg\">" +
                "<div class=\"progress_bar\">" +
                "<div class=\"percent\" style=\"background-color:" +
                progressBar.color + "; width:" + colData.b * 100 + "%;\">" +
                "</div>" +
                "</div>" +
                "</div>");
        }
    } else if (progressBar.show_type == 2) {
        //bar模式
        var value2
        if (colData.value !== undefined) {
            value2 = colData.value;
        } else if (colData.v !== undefined) {
            value2 = colData.v;
        }

        if (progressBar.show_ori_value === true) {
            tableStrArray.push(
                "<div class=\"table_progress\">" +
                "<div class=\"progress_number\">" + value2 +
                "</div>" +
                "<div class=\"progress_container\">" +
                "<div class=\"progress_bar\">" +
                "<div class=\"percent\" style=\"background-color:" +
                progressBar.color + "; width:" + colData.b * 100 + "%;\">" +
                "</div>" +
                "</div>" +
                "</div>" +
                "<div class=\"progress_number\">" + value2 +
                "</div>" +
                "</div>");
        } else {
            tableStrArray.push(
                "<div class=\"table_progress\">" +
                "<div class=\"progress_container\">" +
                "<div class=\"progress_bar\">" +
                "<div class=\"percent\" style=\"background-color:" +
                progressBar.color + "; width:" +
                colData.b * 100 + "%;\">" +
                "</div>" +
                "</div>" +
                "</div>" +
                "</div>");
        }
    }
}

function _onClickHeader(widgetId) {
    if (myMaskIsShow[widgetId] !== undefined && myMaskIsShow[widgetId] !== null) {
        _hideMask(widgetId, myCell[widgetId]);
        myMaskIsShow[widgetId] = null;
    }
}

/**
 * 
 * @param {*} widgetId 
 * @param {*} rowIndex 第几行被点击
 * @param {*} colIndex 第几列被点击
 * @param {*} isColFold true 列折叠 false 行折叠
 * @param {*} foldType  0 没有折叠状态 1 加号、被折叠状态 -1 减号可折叠状态
 */
function _onClickFold(widgetId, rowIndex, colIndex, isColFold, foldType) {
    window.huoban.onTableFoldClick(widgetId, rowIndex, colIndex, isColFold, foldType);
}

function _onClickCell(obj, event, isDataField, widgetId, isGroupField, rowIndex, colIndex) {
    var widget = _getWidgetById(widgetId);

    var tableValues = widget.values;
    var option = widget.options[0];

    var allFilter = [];

    var colFilters = tableValues.col_filters;
    if (colIndex < colFilters.length) {
        var colFilter = colFilters[colIndex].filter;
        if (colFilter !== undefined) {
            if (colFilter.and !== undefined && colFilter.and.length > 0) {
                for (var n = 0; n < colFilter.and.length; n++) {
                    allFilter.push(colFilter.and[n]);
                }
            }
        }
    }

    var rowFilter = myRowFilterArray[widgetId][rowIndex];
    if (rowFilter !== undefined) {
        for (var i = 0; i < rowFilter.length; i++) {
            if (rowFilter[i].and !== undefined && rowFilter[i].and.length > 0) {
                for (var j = 0; j < rowFilter[i].and.length; j++) {
                    allFilter.push(rowFilter[i].and[j]);
                }
            }
        }
    }
    if (myPlatform) {
        //没有多关联，直接传递筛选条件给View
        if (myHasRelation[widgetId] !== true) {
            if (allFilter.length > 0) {
                //有filter
                window.huoban.onTableFilter(widgetId, JSON.stringify(allFilter));
            }else{
                if (isDataField === true) {
                    window.huoban.onTableFilter(widgetId, null);
                }
            }
            return;
        }
    } else {

    }

    _setCellObj(widgetId, obj);

    //点击非数据列
    if (isGroupField === true) {
        if (myMaskIsShow[widgetId] !== undefined && myMaskIsShow[widgetId] !== null) {
            _hideMask(widgetId, obj);
            myMaskIsShow[widgetId] = null;
        }
        return;
    }

    //可点击状态下的数据列
    if (myClickStatus[widgetId] === undefined || myClickStatus[widgetId] === true) {
        if (myMaskIsShow[widgetId] !== undefined && myMaskIsShow[widgetId] !== null) {
            if (myMaskIsShow[widgetId] === (rowIndex + "" + colIndex)) {
                //隐藏Mask并清空数据，不再需要关联和筛选的传递
                _hideMask(widgetId, obj, rowIndex, colIndex);
                myMaskIsShow[widgetId] = null;
                return;
            } else {
                myMaskIsShow[widgetId] = rowIndex + "" + colIndex;
                _showMask(widgetId, obj, rowIndex, colIndex);
            }
        } else {
            myMaskIsShow[widgetId] = rowIndex + "" + colIndex;
            _showMask(widgetId, obj, rowIndex, colIndex);
        }
    }

    if (allFilter.length > 0) {
        //有filter
        _relationWidgetFilter(widgetId, allFilter);
    } else {
        //没有任何filter
        if (myPlatform) {

        } else {
            //iOS
        }
    }
}

function _relationWidgetFilter(widgetId, allFilter) {
    var widgetFilters = {};
    var widgetFilterArray = [];
    var widget = _getWidgetById(widgetId);

    var option = widget.options[0];

    if (option.chart.relation !== undefined && option.chart.relation.options !== undefined) {
        var relationWidgetOptions = option.chart.relation.options;
        var targetWidgetIds = relationWidgetOptions.target_widget_ids;
        var widgetTableFields = relationWidgetOptions.widget_table_fields;

        for (var i = 0; i < targetWidgetIds.length; i++) {
            var targetWidgetId = targetWidgetIds[i];

            var widgetFilter = {};
            widgetFilter.widget_id = targetWidgetId;

            var filter = {};
            var ands = [];
            var widgetIdStr = targetWidgetId.toString();

            var fieldsRelations = widgetTableFields[widgetIdStr].fields_relations;

            for (var j = 0; j < fieldsRelations.length; j++) {
                var sourceFieldId = fieldsRelations[j].source_field_id;
                var targetFieldId = fieldsRelations[j].target_field_id;

                for (var m = 0; m < allFilter.length; m++) {
                    if (allFilter[m].field == sourceFieldId) {
                        //更换fieldID为targetFieldId
                        var newFilter = JSON.parse(JSON.stringify(allFilter[m]));
                        newFilter.field = targetFieldId;
                        ands.push(newFilter);
                    }
                }
            }

            filter.and = ands;
            widgetFilter.filter = filter;
            widgetFilterArray.push(widgetFilter);
        }

        widgetFilters.widgets = widgetFilterArray;

        if (myPlatform) {
            window.huoban.onTableFilter(widgetId, JSON.stringify(allFilter));
            window.huoban.onWidgetsFilter(widgetId, JSON.stringify(widgetFilters));
        } else {
            //iOS
        }
    } else {
        //没有任何相关联的widget
        if (myPlatform) {
            window.huoban.onTableFilter(widgetId, JSON.stringify(allFilter));
        } else {
            //iOS
        }
    }
}


function _clearRelationWidgetFilter(widgetId) {
    var widgetFilters = {};
    var widgetFilterArray = [];
    var widget = _getWidgetById(widgetId);

    var option = widget.options[0];

    if (option.chart.relation !== undefined && option.chart.relation.options !== undefined) {
        var relationWidgetOptions = option.chart.relation.options;
        var targetWidgetIds = relationWidgetOptions.target_widget_ids;
        var widgetTableFields = relationWidgetOptions.widget_table_fields;

        for (var i = 0; i < targetWidgetIds.length; i++) {
            var targetWidgetId = targetWidgetIds[i];

            var widgetFilter = {};
            widgetFilter.widget_id = targetWidgetId;

            var filter = {};
            var ands = [];

            filter.and = ands;
            widgetFilter.filter = filter;
            widgetFilterArray.push(widgetFilter);
        }

        widgetFilters.widgets = widgetFilterArray;
        if (myPlatform) {
            window.huoban.clearWidgetFilter(widgetId, JSON.stringify(widgetFilters));
        } else {

        }

    }
}


function _hasRelation(option) {
    if (option.chart.relation !== undefined && option.chart.relation.options !== undefined) {
        var relationWidgetOptions = option.chart.relation.options;
        var targetWidgetIds = relationWidgetOptions.target_widget_ids;

        if (targetWidgetIds !== undefined && targetWidgetIds.length > 0) {
            return true;
        }
    }
}

function _setRowFilter(widgetId, colData, rowIndex) {
    if (colData.filter !== undefined) {
        for (var i = 0, k = rowIndex; i < colData.rowspan; i++) {
            if (myRowFilterArray[widgetId][k + i] === undefined) {
                var singleRowArray = [];
                singleRowArray.push(colData.filter);
                myRowFilterArray[widgetId][k + i] = singleRowArray;
            } else {
                myRowFilterArray[widgetId][k + i].push(colData.filter);
            }
        }
    }
}

function _jsonLength(obj) {
    var size = 0,
        key;
    for (key in obj) {
        if (obj.hasOwnProperty(key)) {
            size++;
        }
    }
    return size;
}

function _getWidgetById(widgetId) {
    return myWidget[widgetId];
}

function _setCellObj(widgetId, cellObj) {
    if (myCell[widgetId] !== undefined) {
        var oldCellObj = myCell[widgetId];
        if (_hasClass(oldCellObj, "select_cell")) {
            _removeClass(oldCellObj, "select_cell");
        }
    }

    myCell[widgetId] = cellObj;
}

//显示遮罩层
function _showMask(widgetId, cellObj, rowIndex, colIndex) {
    var table = document.getElementById("table" + widgetId);
    _addClass(table, "select_table");
    _addClass(cellObj, "select_cell");
}

//隐藏遮罩层
function _hideMask(widgetId, cellObj, rowIndex, colIndex) {
    if (myMaskIsShow[widgetId] !== undefined && myMaskIsShow[widgetId] !== null) {
        _clearRelationWidgetFilter(widgetId);
        myMaskIsShow[widgetId] = null;
    }
    var table = document.getElementById("table" + widgetId);

    if (_hasClass(table, "select_table")) {
        _removeClass(table, "select_table");
    }

    if (cellObj !== undefined) {
        if (_hasClass(cellObj, "select_cell")) {
            _removeClass(cellObj, "select_cell");
        }
    }
}
//隐藏遮罩层
function _hideMask(widgetId, cellObj) {
    if (myMaskIsShow[widgetId] !== undefined && myMaskIsShow[widgetId] !== null) {
        _clearRelationWidgetFilter(widgetId);
        myMaskIsShow[widgetId] = null;
    }

    var table = document.getElementById("table" + widgetId);
    if (_hasClass(table, "select_table")) {
        _removeClass(table, "select_table");
    }

    if (cellObj !== undefined) {
        if (_hasClass(cellObj, "select_cell")) {
            _removeClass(cellObj, "select_cell");
        }
    }
}

function _hasClass(el, className) {
    if (el.classList) {
        return el.classList.contains(className);
    } else {
        return !!el.className.match(new RegExp('(\\s|^)' + className + '(\\s|$)'));
    }
}

function _addClass(el, className) {
    if (el.classList) {
        el.classList.add(className);
    } else if (!_hasClass(el, className)) { el.className += " " + className }
}

function _removeClass(el, className) {
    if (el.classList) {
        el.classList.remove(className)
    } else if (_hasClass(el, className)) {
        var reg = new RegExp('(\\s|^)' + className + '(\\s|$)');
        el.className = el.className.replace(reg, ' ');
    }
}