var Widgets = {};
var myChart;
var myWidget;
var highLightActionsSaved = Array(); // 高亮的标记，保存
var platform = "ios"; // 切换平台
var myDrillVisible;
var myIsFullScreen;

Widgets.createEChart = function(widget, isFullScreen) {
    myWidget = widget;
    myIsFullScreen = isFullScreen;
    //    window.huoban.toast(JSON.stringify(myWidget));
    var widgetChartBox = document.body;
    //    widgetChartBox.style.height = ((widget.layout.size[1] - 1) * 45 - 10) + "px";
    var chartOption = _parseWidget(widget, widgetChartBox, false);
    //    window.huoban.toast(JSON.stringify(chartOption));
    myChart = echarts.init(widgetChartBox);

    myChart.on('click', function(params) {
//                window.huoban.toast(JSON.stringify(params.seriesIndex));
        // 标记高亮
        if (params && params.componentType == 'markLine') { return; }
        _highlight(myWidget, this, params);
        var seriesIndex = params.seriesIndex;
        var dataIndex = params.dataIndex;
        var seriesName = params.name;
        var x = (params.event.event.changedTouches[0].clientX - 50);
        var y = (params.event.event.changedTouches[0].clientY + 45);

        window.huoban.onDrillClick(myWidget.widget_id, seriesIndex, dataIndex, seriesName, x, y);
    });

    myChart.on('mouseout', function(params) {
        // 标记高亮
        _highlightOnMouseOut(myWidget, this, params);
    });
    myChart.setOption(chartOption);
}

Widgets.updateEChartByWidget = function(widget) {
    if (myChart === undefined) return;
    myWidget = widget;

    var widgetChartBox = document.body;
    var chartOption = _parseWidget(myWidget, widgetChartBox, myDrillVisible);
    myChart.setOption(chartOption, true);
    myChart.resize();
}

Widgets.updateEChartByLegend = function(widget) {
    if (myChart === undefined) return;

    var chartOption = _parseWidgetByLegend(widget);
    myChart.setOption(chartOption, true);
    myChart.resize();
}

Widgets.setDrillViewVisible = function(isVisible) {
    if (myChart === undefined) return;
    var widgetChartBox = document.body;
    myDrillVisible = isVisible;
    var chartOption = _parseWidget(myWidget, widgetChartBox, isVisible);
    myChart.setOption(chartOption, true);
    myChart.resize();
}

Widgets.clearEChart = function() {
    if (myChart === undefined) return;
    myChart.clear();
    myChart.resize();
}

/// 解析widget
function _parseWidget(widget, widgetChartBox, drillViewIsVisible) {
    // 未处理过的options数据是一个数组，这里曾经在iOS端进行了缩减层级的操作
    // window.huoban.toast(JSON.stringify(widget));
    var options = widget.options[0];
    var values = widget.values;

    var chartOption = { series: values.series };
    var colors
    if (['map'].indexOf(options.chart_type) == -1) {
        chartOption = parseOption(options, values);
    } else {
        eval("_parseChartFor" + options.chart_type.firstUpperCase())(options, values, chartOption);
    }
    colors = chartOption.color;

    var total = _getTotal(options, values);
    var totalHeight = 0;
    if (total !== undefined) {
        totalHeight = 35;
        window.huoban.setTotal(widget.widget_id, total);
    } else {
        window.huoban.hideTotal();
    }

    if (drillViewIsVisible !== undefined && drillViewIsVisible == true) {
        totalHeight += 35;
    }

    if (['single'].indexOf(options.chart_type) != -1) {
        totalHeight += 35;
    }
    // if (widget.layout === undefined) {
    //     window.huoban.toast("undifine:" + widget.widget_id);
    //     window.huoban.toast(JSON.stringify(widget));
    // }
    // 解析颜色配置
    var showColor = false;
    if (colors != undefined) {
        chartOption.color = colors;
        if (values.legend != undefined && values.legend.length > 1) {
            var chartColors = {};
            chartColors.color = colors;
            showColor = true;
            window.huoban.colors(JSON.stringify(chartColors));
            if (myIsFullScreen) {
            } else {
                widgetChartBox.style.height = ((widget.layout.size[1] - 1) * 45 - 10 - 35 - totalHeight) + "px";
            }
        } else {
            if (myIsFullScreen) {
            } else {
                widgetChartBox.style.height = ((widget.layout.size[1] - 1) * 45 - 10 - totalHeight) + "px";
            }
        }
    } else {
        if (myIsFullScreen) {
        } else {
            widgetChartBox.style.height = ((widget.layout.size[1] - 1) * 45 - 10 - totalHeight) + "px";
        }
    }

//    window.huoban.toast("height lll:" + widgetChartBox.style.height);
    if (showColor === false) {
        window.huoban.hideColors();
    }

    if (chartOption.tooltip != undefined) {
        chartOption.tooltip.confine = true;
    }

    if (['single'].indexOf(options.chart_type) != -1) {
        chartOption.grid.bottom = "10px";
    }

    //    else {
    //        if (chartOption.grid !== undefined) {
    //            var bottom = parseInt(chartOption.grid.bottom || 0);
    //            if (bottom !== 0) {
    //                if (bottom > 8) {
    //                    bottom -= 8;
    //                } else if (bottom > 5) {
    //                    bottom -= 5;
    //                }
    //            }
    //            chartOption.grid.bottom = bottom + "px";
    //        }
    //    }
    //    window.huoban.toast("bottom:" + chartOption.grid.bottom);
    //        if (chartOption.series) {
    //            for (var index in chartOption.series) {
    //                chartOption.series[index].symbolSize = 10;
    //            }
    //        }
    return chartOption;
}

function _getTotal(options, values) {
    if (options.chart !== undefined &&
        options.chart.count_data !== undefined &&
        options.chart.count_data.is_show !== undefined &&
        options.chart.count_data.is_show === true) {
        var type = options.chart.count_data.count_type;
        if (values.total !== undefined) {
            var totalString = values.total;
            var showType;
            if (options.chart && options.chart.y_axis) {
                for (var key in options.chart.y_axis) {
                    showType = options.chart.y_axis[key].show_type;
                    break;
                }
            } else if (options.chart && options.chart.values) {
                for (var key in options.chart.values) {
                    showType = options.chart.values[key].show_type;
                    break;
                }
            }

            if (showType != undefined) {
                if (showType.thousandth) {
                    totalString = _comdify(totalString.toString());
                }
                if (showType.compose == 'suffix') {
                    if (showType.unit !== undefined) {
                        totalString = totalString + showType.unit;
                    }
                } else {
                    if (showType.unit !== undefined) {
                        totalString = showType.unit + totalString;
                    }
                }
            }
            return type + '-' + totalString;
        }
    }
}

/// 千分位
function _comdify(n) {　　
    var re = /\d{1,3}(?=(\d{3})+$)/g;　　
    var n1 = n.replace(/^(\d+)((\.\d+)?)$/, function(s, s1, s2) { return s1.replace(re, "$&,") + s2; });　　
    return n1;
}

/// 解析widget
function _parseWidgetByWidget(widget, isHighLight) {
    // 未处理过的options数据是一个数组，这里曾经在iOS端进行了缩减层级的操作
    var options = widget.options[0];
    var values = widget.values;

    var chartOption = { series: values.series };
    var colors
    if (['map'].indexOf(options.chart_type) == -1) {
        chartOption = parseOption(options, values, null, isHighLight);
    } else {
        eval("_parseChartFor" + options.chart_type.firstUpperCase())(options, values, chartOption);
    }

    //设置总和
    if (isHighLight == false) {

        var total = _getTotal(options, values);
        if (total !== undefined) {
            window.huoban.setTotal(widget.widget_id, total);
        } else {
            window.huoban.hideTotal();
        }
    }

    var showColor = false;
    colors = chartOption.color;
    if (colors != undefined) {
        chartOption.color = colors;
        if (values.legend != undefined && values.legend.length > 1) {
            var chartColors = {};
            chartColors.color = colors;
            showColor = true;
            window.huoban.colors(JSON.stringify(chartColors));
        } else {

        }
    }

    if (showColor === false) {
        window.huoban.hideColors();
    }

    if (chartOption.tooltip != undefined) {
        chartOption.tooltip.confine = true;
    }
    //    if (chartOption.series) {
    //        for (var index in chartOption.series) {
    //            chartOption.series[index].symbolSize = 10;
    //        }
    //    }
    return chartOption;
}


// 解析widget
function _parseWidgetByLegend(widget) {
    // 未处理过的options数据是一个数组，这里曾经在iOS端进行了缩减层级的操作
    var options = widget.options[0];
    var values = widget.values;

    var chartOption = { series: values.series };
    var colors
    if (['map'].indexOf(options.chart_type) == -1) {
        chartOption = parseOption(options, values);
    } else {
        eval("_parseChartFor" + options.chart_type.firstUpperCase())(options, values, chartOption);
    }
    colors = chartOption.color;
    if (colors != undefined) {
        chartOption.color = colors;
    }

    if (chartOption.tooltip != undefined) {
        chartOption.tooltip.confine = true;
    }

    var legendStatus = widget.legend_status;
    if (values.legend !== undefined && values.legend.length > 1) {
        var legend = {};
        legend.show = false;
        legend.selected = {};
        var valuesLegend = values.legend;

        if (legendStatus !== undefined) {
            for (var i = 0; i < legendStatus.length; i++) {
                var name = valuesLegend[i].name;
                if (legendStatus[i]) {
                    legend.selected[name] = false;
                } else {
                    legend.selected[name] = true;
                }
            }
        } else {
            for (var j = 0; j < valuesLegend.length; j++) {
                var name = valuesLegend[j].name;
                legend.selected[name] = true;
            }
        }
        chartOption.legend = legend;
    }

    //     if (chartOption.series) {
    //         for (var index in chartOption.series) {
    //             chartOption.series[index].symbolSize = 10;
    //         }
    //     }
    return chartOption;
}

/// 具体解析图表----------
/// 地图



function _parseChartForMap(options, values, chartOption) {
    var mapRange = options.chart.map_range == undefined ? "china" : pinyin.getFullChars(options.chart.map_range.name);
    if (mapRange == 'zhongguo') {
        mapRange = 'china';
    }

    var name = options.chart.map_range.name;
    if (name == '陕西省') {
        mapRange = 'shanxi1';
    } else if (name == '西藏') {
        mapRange = 'xizang';
    } else if (name == '内蒙古') {
        mapRange = 'neimenggu';
    } else if (name == '重庆') {
        mapRange = 'chongqing';
    }

    mapRange = mapRange.replace(/shi|sheng|tebiehangzhengqu|huizuzizhiqu|zhuangzuzizhiqu|weiwuerzizhiqu|zizhiqu/, '')
    var fileUrl = "scripts/map/" + mapRange + ".js";
    includeJS(fileUrl);

    chartOption.series = [{
        type: 'map',
        mapType: mapRange,
        label: { normal: { show: true } },
        emphasis: { show: true },
        data: values.series[0].data
    }];
    parseOption(options, values, chartOption)
}

/// echart高亮模式
function _highlight(widget, myEChart, params) {
    var options = widget.options[0];
    if (options.chart_type != "map" && options.chart_type != "funnel") {
        // 标记高亮
        var highlightAction = {
            type: "highlight",
            seriesIndex: params.seriesIndex,
            dataIndex: params.dataIndex
        };
        var downplayAction = {
            type: "downplay",
            seriesIndex: params.seriesIndex,
            dataIndex: params.dataIndex
        };

        var savedAction = highLightActionsSaved[widget.widget_id];
        if (JSON.stringify(savedAction) != JSON.stringify(highlightAction)) {
            var chartOption = _parseWidgetByWidget(widget, true);
            myEChart.setOption(chartOption);
            myEChart.dispatchAction(downplayAction);
            myEChart.dispatchAction(highlightAction);
            highLightActionsSaved[widget.widget_id] = highlightAction;
        } else {
            var chartOption = _parseWidgetByWidget(widget, false);
            myEChart.dispatchAction(downplayAction);
            myEChart.setOption(chartOption, true);
            highLightActionsSaved[widget.widget_id] = null;
        }
    }
}

/// 解决触摸或鼠标移出echart时造成的失去高亮的问题[这是解决echart自身的bug]
function _highlightOnMouseOut(widget, myEChart, params) {
    var options = widget.options[0];
    if (options.chart_type != "map" && options.chart_type != "funnel") {
        var savedAction = highLightActionsSaved[widget.widget_id];
        if (savedAction != null) {
            var chartOption = _parseWidget(widget, true);
            myEChart.setOption(chartOption);
            savedAction.type = "downplay";
            myEChart.dispatchAction(savedAction);
            savedAction.type = "highlight";
            myEChart.dispatchAction(savedAction)
        }
    }
}

/// 取消高亮
function _downplay(widget) {
    var options = widget.options[0];
    var myEChart = charts[widget.widget_id];
    var chartOption = _parseWidget(widget, false);
    myEChart.setOption(chartOption, true);

    var savedAction = highLightActionsSaved[widget.widget_id];
    if (savedAction != null) {
        savedAction.type = "downplay";
        myEChart.dispatchAction(savedAction);
    }
}

function includeJS(file) {
    var head = $("head").remove("script[role='reload']");
    $("<scri" + "pt>" + "</scr" + "ipt>").attr({ role: 'reload', src: file, type: 'text/javascript' }).appendTo(head);

}

/// 首字母大写
String.prototype.firstUpperCase = function() {
    return this.replace(/^\S/, function(s) { return s.toUpperCase(); });
}