'use strict';

var COMPARE_ITEMS = [{
  name: '环比',
  value: 'last'
}, {
  name: '周同比',
  value: 'week'
}, {
  name: '月同比',
  value: 'month'
}, {
  name: '季同比',
  value: 'quarter'
}, {
  name: '年同比',
  value: 'year'
}, {
  name: '增长率',
  value: 'incr_ratio'
}, {
  name: '增长值',
  value: 'incr_value'
}, {
  name: '原值',
  value: 'ori_value'
}, {
  name: '总排行',
  value: 'total'
}, {
  name: '组内排行',
  value: 'group'
}, {
  name: '占比',
  value: 'show_percent'
}];

var TWO_COLORS_GRADIENT = {
  1: ['#C6E0D0', '#5CA87A'],
  2: ['#B5BDC3', '#2E4555'],
  3: ['#E9B7B5', '#C1302B'],
  4: ['#D3C6BD', '#825C42'],
  5: ['#D3BEDC', '#80499D'],
  6: ['#C7DEE1', '#61A0A9'],
  7: ['#C5B3DA', '#5B2B99'],
  8: ['#E6D7D2', '#B98E7E'],
  9: ['#DAB8CB', '#95386B'],
  10: ['#B0CCC7', '#1E6D5F'],
  11: ['#BAD4E5', '#3C85B5'],
  12: ['#D0D2EB', '#7980C8'],
  13: ['#DEDFCC', '#A0A46B'],
  14: ['#C7D1D6', '#607D8B'],
  15: ['#F6CECE', '#E37373'],
  16: ['#CCCCCE', '#6E7074']
};

var THREE_COLORS_GRADIENT = {
  1: ['#5CA87A', '#CDD9A9', '#D36D30'],
  2: ['#C1302B', '#C7DEE7', '#3C85B5'],
  3: ['#61A0A9', '#CDE1E6', '#2E4555'],
  4: ['#5B2B99', '#B9BCD8', '#7980C8'],
  5: ['#825C42', '#D6D8B3', '#A0A46B'],
  6: ['#1E6D5F', '#B2D5D3', '#61A0A9'],
  7: ['#B98E7E', '#C8E1E5', '#61A0A9'],
  8: ['#D5B1B0', '#F6E2E2', '#C1302B'],
  9: ['#825C42', '#E4CDC5', '#B98E7E'],
  10: ['#A0A46B', '#E6E9C6', '#D68E5E'],
  11: ['#61A0A9', '#C0DEE3', '#E37373'],
  12: ['#80499D', '#D4BADD', '#C1302B'],
  13: ['#61A0A9', '#CCC4BE', '#825C42'],
  14: ['#3C85B5', '#C4D5DF', '#1E6D5F'],
  15: ['#95386B', '#D8BCCB', '#607D8B'],
  16: ['#7980C8', '#E5CDCD', '#E37373']
};

var MULTIPLE_COLORS_GRADIENT = {
  1: ['#5EAA7D', '#2E4555', '#C02F2B', '#825C43', '#206D5F', '#3C85B5', '#607D8B', '#7A7EC7', '#62A0A9', '#80459B', '#B98E7E', '#94366A', '#5B2B99', '#E37373', '#A0A46B', '#6E7074'],
  2: ['#5EAA7D', '#81C19B', '#82BA84', '#C0DBC3', '#3B757E', '#66A7B1', '#BAD8DD', '#1D877A', '#62A79E', '#98D3CB', '#2A99AB', '#60BECE', '#96DEEA', '#5087A6', '#7CACC8'],
  3: ['#2E4555', '#4B6374', '#738A9B', '#B6C7D5', '#3E84B4', '#71A5CA', '#A0C9E4', '#18609F', '#408ACA', '#5DA8E9', '#81C3FC', '#395B84', '#4C6E97', '#7594B9', '#BFD6F2'],
  4: ['#C02F2B', '#BB625F', '#EC5E5E', '#EC9C99', '#F0B1B1', '#8F1D1D', '#A3401B', '#C27458', '#E4A28A', '#94163F', '#B34575', '#CD789D', '#A94788', '#C269A4', '#E595CA'],
  5: ['#825C43', '#C27D4F', '#E8B18B', '#F0D8C8', '#947367', '#B3A29C', '#DAD8D7', '#8E422B', '#BF684F', '#E79B87', '#F9CEC2', '#9C7437', '#BA945C', '#CFB998', '#EEDBBE'],
  6: ['#206D5F', '#429283', '#6CB8A9', '#AFD1CA', '#3C7940', '#69A56F', '#9BCEA1', '#679F3D', '#8EC46C', '#B9D7A8'],
  7: ['#3C85B5', '#446599', '#577DBA', '#408CD7', '#8FBBE8', '#30A0AD', '#6DC9D3', '#ACE6EC', '#5DC3F0', '#A3E2FE'],
  8: ['#607D8B', '#7E9AA7', '#8DB5C8', '#C7DEE8', '#505A5F', '#657279', '#889398', '#BEC3C5', '#838990', '#ACB9C8'],
  9: ['#7A7EC7', '#9E9BD4', '#CAC7E9', '#6673CF', '#8F99FD', '#6F66AD', '#8077BB', '#9E96D8', '#7C66AC', '#9A83CD'],
  10: ['#62A0A9', '#84B0A7', '#ABDDD3', '#81B699', '#8ECEAB', '#ACE5C6', '#81B6AB', '#AAC8CD'],
  11: ['#80459B', '#7C68A2', '#AE58C9', '#9879C7', '#BF9EEC', '#707ECB', '#8A93DB', '#B4B7E3'],
  12: ['#B98E7E', '#CDAB9F', '#E7B8A7', '#E6D0C8', '#D6A0A0', '#E5BBBB', '#F2DADA', '#E6CEDB'],
  13: ['#94366A', '#C178A0', '#F1BED9', '#D85682', '#EE9CB8', '#AD5A75', '#C0748D', '#E085A3'],
  14: ['#5B2B99', '#7E4EA3', '#B07BD4', '#714196', '#9B52AD'],
  15: ['#E37373', '#BB6161', '#D98989', '#AF576E', '#B4677F'],
  16: ['#A0A46B', '#BAC18E', '#D6DDB3', '#95AB81', '#B1CC9B'],
  17: ['#6E7074', '#84878C', '#A4A7AD', '#767079', '#9A959F']
};

var Func = {
  getStrWidthByFontSize: function getStrWidthByFontSize(content) {
    return (content || '').replace(/[\u4E00-\u9FA5‘“”【】（）。；：，？！《》『』￥·]/ig, '^^').length * 6.18;
  },
  formatNumByUnitAndThoundth: function formatNumByUnitAndThoundth(value, isThoundth, unit, position) {
    var ret = value || '0';
    if (isThoundth) {
      ret = ret.toString().replace(/^\d+/g, function (m) {
        return m.replace(/(?=(?!^)(\d{3})+$)/g, ',');
      });
    }

    unit = unit || '';
    if (position == 'suffix') {
      ret = ret + unit;
    } else if (position == 'prefix') {
      ret = unit + ret;
    }

    return ret;
  }
};

function parseOption(chartOption, data, option, highlight) {
  var widgetChart = chartOption.chart,
      widgetStyle = chartOption.style,
      widgetAnalyze = chartOption.analyze,
      widgetChartValue = _.values(widgetChart.values)[0] || {},
      colors = [],
      showTypeConfigs = [],
      showTypeJsonConfigs = [],
      xAxisData = [];

  var parseColor = function parseColor(hexStr) {
    return hexStr.length === 4 ? hexStr.substr(1).split('').map(function (s) {
      return 0x11 * parseInt(s, 16);
    }) : [hexStr.substr(1, 2), hexStr.substr(3, 2), hexStr.substr(5, 2)].map(function (s) {
      return parseInt(s, 16);
    });
  };

  option = option || { series: data.series };

  var chartType = chartOption.chart_type;

  switch (chartType) {
    case 'pie':
      var pieOption = {
        labelLine: {
          normal: {
            length2: 8
          }
        },

        radius: [0, '75%']
      };
      if (widgetStyle && widgetStyle.graph.type === 'ring') {
        pieOption.radius = ['50%', '70%'];
      }

      option.series = _.map(option.series, function (seriesData) {
        return _.extend({}, seriesData, pieOption);
      });

      var loopIndex = 0;
      var defaultColors = MULTIPLE_COLORS_GRADIENT[1];
      if (widgetStyle && !_.isEmpty(widgetStyle.pie_color_series)) {
        defaultColors = widgetStyle.pie_color_series;
      }
      if (widgetStyle && !_.isEmpty(data.legend)) {
        _.forEach(data.series, function (seriesData) {
          _.forEach(seriesData.data, function (singleData) {
            var filterField = _.find(widgetStyle.pie_color, function (pieColor) {
              return pieColor.true_name == singleData.true_name;
            });
            if (!defaultColors[loopIndex]) loopIndex = 0;
            if (filterField) {
              colors.push(filterField.color);
            } else {
              colors.push(defaultColors[loopIndex]);
            }
            loopIndex++;
          });
        });
      } else {
        if (!_.isEmpty(data.legend)) {
          _.forEach(data.legend, function (legendData) {
            if (!defaultColors[loopIndex]) loopIndex = 0;
            colors.push(defaultColors[loopIndex]);
            loopIndex++;
          });
        }
      }

      if (widgetChart && widgetChartValue) {
        option.tooltip = {
          trigger: 'item',
          textStyle: {
            fontSize: 12,
            fontWeight: 'normal'
          },
          formatter: function formatter(params) {
            if (!_.isEmpty(params)) {
              var value = params.value,
                  name = params.name,
                  percent = params.percent,
                  seriesName = params.seriesName;

              var formatName = name + '<br/>' + seriesName + '\uFF1A';
              var showType = widgetChartValue.show_type;
              var isCompareIncrRatio = false;
              if (widgetChartValue.compare) {
                var _widgetChartValue$com = widgetChartValue.compare,
                    field_id = _widgetChartValue$com.field_id,
                    type = _widgetChartValue$com.type,
                    _value = _widgetChartValue$com.value;

                if (field_id && type && _value == 'incr_ratio') {
                  isCompareIncrRatio = true;
                  var attachedName = _.find(COMPARE_ITEMS, { value: _value }).name;
                  formatName = name + '<br/>' + data.series[0].name + '-' + attachedName + '\uFF1A';
                }
              }

              var formatVal = '';
              if (value) {
                if (showType) {
                  if (isCompareIncrRatio) {
                    formatVal = '' + Func.formatNumByUnitAndThoundth(value, showType.thousandth, '%', 'suffix');
                  } else {
                    formatVal = Func.formatNumByUnitAndThoundth(value, showType.thousandth, showType.unit, showType.compose) + ' (' + percent + '%)';
                  }
                } else {
                  if (isCompareIncrRatio) {
                    formatVal = value + '%';
                  } else {
                    formatVal = value + ' (' + percent + '%)';
                  }
                }
              } else {
                formatVal = showType && showType.null_value === '0' ? '0' : '--';
              }

              return formatName + formatVal;
            } else {
              return '';
            }
          }
        };
      }

      break;
    case 'scatter':
      var scatterStyle = {
        normal: {
          opacity: 0.9
        }
      };

      option = {
        grid: {
          left: 10,
          right: 15,
          bottom: 10,
          top: 30,
          containLabel: true
        },
        xAxis: _.cloneDeep(data.xAxis),
        yAxis: _.cloneDeep(data.yAxis),
        series: _.map(data.series, function (seriesData) {
          return _.extend({}, seriesData, { itemStyle: scatterStyle });
        })
      };

      if (widgetChart) {
        _.forEach(widgetChart.x_axis, function (xField) {
          if (xField.show_type) {
            showTypeConfigs.push(xField.show_type);
          }
        });
        _.forEach(widgetChart.y_axis, function (yField) {
          if (yField.show_type) {
            showTypeConfigs.push(yField.show_type);
          }
        });
        _.forEach(widgetChart.symbol_size, function (symbolField) {
          if (symbolField.show_type) {
            showTypeConfigs.push(symbolField.show_type);
          }
        });
        _.forEach(widgetChart.saturation, function (saturationField) {
          if (saturationField.show_type) {
            showTypeConfigs.push(saturationField.show_type);
          }
        });
      }
      var xShowType = null;
      var yShowType = null;
      if (showTypeConfigs.length > 1) {
        xShowType = showTypeConfigs[0];
        yShowType = showTypeConfigs[1];

        if (xShowType) {
          option.xAxis.axisLabel = {
            formatter: function formatter(value) {
              return Func.formatNumByUnitAndThoundth(value, xShowType.thousandth, xShowType.unit, xShowType.compose);
            }
          };
        }

        if (yShowType) {
          option.yAxis.axisLabel = {
            formatter: function formatter(value) {
              return Func.formatNumByUnitAndThoundth(value, yShowType.thousandth, yShowType.unit, yShowType.compose);
            }
          };
        }
      }

      option.xAxis.nameLocation = 'middle';
      option.xAxis.nameGap = 30;
      option.xAxis.scale = true;
      option.xAxis.axisTick = {
        show: true,
        alignWithLabel: true
      };
      option.yAxis.scale = true;

      if (data.legend && data.legend.length) {
        if (widgetStyle && widgetStyle.line_color) {
          _.forEach(widgetStyle.line_color, function (lineColor) {
            colors.push(lineColor.color);
          });
        } else {
          var _defaultColors = MULTIPLE_COLORS_GRADIENT[1];
          if (widgetStyle && !_.isEmpty(widgetStyle.colorSeries)) {
            _defaultColors = widgetStyle.colorSeries;
          }

          var _loopIndex = 0;
          _.forEach(data.legend, function (value, index) {
            if (!_defaultColors[_loopIndex]) {
              _loopIndex = 0;
            }
            colors.push(_defaultColors[_loopIndex]);
            _loopIndex++;
          });
        }
      }

      if (widgetChart) {
        option.visualMap = [];

        var valueNum = -1;
        if (!_.isEmpty(widgetChart.x_axis)) {
          valueNum++;
        }

        if (!_.isEmpty(widgetChart.y_axis)) {
          valueNum++;
        }
        if (!_.isEmpty(widgetChart.symbol_size)) {
          valueNum++;
          var symbolData = [];
          _.forEach(option.series, function (seriesData) {
            _.forEach(seriesData.data, function (value) {
              if (value[valueNum]) {
                symbolData.push(value[valueNum]);
              }
            });
          });

          option.visualMap.push({
            left: 'right',
            top: '10%',
            dimension: valueNum,
            show: false,
            min: parseInt(_.min(symbolData) || 0),
            max: parseInt(_.max(symbolData) || 250),
            itemWidth: 20,
            itemHeight: 60,
            calculable: true,
            precision: 0.1,
            text: ['点大小'],
            textGap: 30,
            inRange: {
              symbolSize: [10, 70]
            },
            outOfRange: {
              symbolSize: [10, 70],
              color: ['rgba(255,255,255,.2)']
            },
            controller: {
              inRange: {
                color: [colors[0] || '#c23531']
              },
              outOfRange: {
                color: ['#444']
              }
            }
          });
        }
        if (!_.isEmpty(widgetChart.saturation)) {
          valueNum++;

          var saturationData = [];
          _.forEach(option.series, function (seriesData) {
            _.forEach(seriesData.data, function (value) {
              if (value[valueNum]) {
                saturationData.push(value[valueNum]);
              }
            });
          });
          option.visualMap.push({
            left: 'right',
            bottom: '5%',
            dimension: valueNum,
            show: false,
            min: parseInt(_.min(saturationData) || 0),
            max: parseInt(_.max(saturationData) || 50),
            itemWidth: 20,
            itemHeight: 60,
            calculable: true,
            precision: 0.1,
            text: ['深浅度'],
            textGap: 30,
            inRange: {
              colorLightness: [0.9, 0.4]
            },
            outOfRange: {
              color: ['rgba(255,255,255,.2)']
            },
            controller: {
              inRange: {
                color: [colors[0] || '#c23531']
              },
              outOfRange: {
                color: ['#444']
              }
            }
          });
        }
      }

      if (widgetStyle) {
        var x_axis = widgetStyle.x_axis,
            y_axis = widgetStyle.y_axis,
            show_scale = widgetStyle.show_scale,
            section = widgetStyle.section,
            values_title = widgetStyle.values_title;

        if (x_axis.is_show) {
          option.xAxis.show = true;
        } else {
          option.xAxis.show = false;
          option.grid.bottom = -8;
        }
        if (!x_axis.show_title) {
          option.xAxis.name = '';
        } else {
          option.grid.bottom = 30;
        }
        if (x_axis.max) {
          option.xAxis.max = x_axis.max;
        }
        if (x_axis.min) {
          option.xAxis.min = x_axis.min;
        }
        if (y_axis.is_show) {
          option.yAxis.show = true;
        } else {
          option.yAxis.show = false;
          option.grid.left = -32;
        }
        if (!y_axis.show_title) {
          option.yAxis.name = '';
        } else {
          option.grid.top = Math.max(30, option.grid.top || 0);
        }
        if (y_axis.max) {
          option.yAxis.max = y_axis.max;
        }
        if (y_axis.min) {
          option.yAxis.min = y_axis.min;
        }
        if (values_title.is_show) {
          var rotate = '0';
          var offset = [0, 0];
          if (values_title.title == 'x_max') {
            _.forEach(option.series, function (seriesData) {
              seriesData.markPoint = {
                data: [{
                  type: 'max',
                  name: '最大值',
                  valueIndex: 0,
                  symbolRotate: rotate,
                  label: {
                    normal: {
                      offset: offset,
                      formatter: function formatter(params) {
                        var currentFieldKeys = _.keys(widgetChart.x_axis);
                        if (currentFieldKeys && currentFieldKeys.length == 1) {
                          var currentField = widgetChart.x_axis[currentFieldKeys[0]];
                          return Func.formatNumByUnitAndThoundth(params.value, currentField.show_type.thousandth, currentField.show_type.unit, currentField.show_type.compose);
                        } else {
                          return params.value;
                        }
                      }
                    }
                  }
                }]
              };
            });
          } else if (values_title.title == 'x_min') {
            _.forEach(option.series, function (seriesData, index) {
              seriesData.markPoint = {
                data: [{
                  type: 'min',
                  name: '最小值',
                  valueIndex: 0,
                  symbolRotate: rotate,
                  label: {
                    normal: {
                      offset: offset,
                      formatter: function formatter(params) {
                        var currentField = widgetChart.x_axis;
                        if (currentField && currentField.show_type) {
                          return Func.formatNumByUnitAndThoundth(params.value, currentField.show_type.thousandth, currentField.show_type.unit, currentField.show_type.compose);
                        } else {
                          return params.value;
                        }
                      }
                    }
                  }
                }]
              };
            });
          } else if (values_title.title == 'x_and') {
            _.forEach(option.series, function (seriesData, index) {
              seriesData.markPoint = {
                data: [{
                  type: 'min',
                  name: '最小值',
                  valueIndex: 0,
                  symbolRotate: rotate,
                  label: {
                    normal: {
                      offset: offset,
                      formatter: function formatter(params) {
                        var currentFieldKeys = _.keys(widgetChart.x_axis);
                        if (currentFieldKeys && currentFieldKeys.length == 1) {
                          var currentField = widgetChart.x_axis[currentFieldKeys[0]];
                          return Func.formatNumByUnitAndThoundth(params.value, currentField.show_type.thousandth, currentField.show_type.unit, currentField.show_type.compose);
                        } else {
                          return params.value;
                        }
                      }
                    }
                  }
                }, {
                  type: 'max',
                  name: '最大值',
                  valueIndex: 0,
                  symbolRotate: rotate,
                  label: {
                    normal: {
                      offset: offset,
                      formatter: function formatter(params) {
                        var currentFieldKeys = _.keys(widgetChart.x_axis);
                        if (currentFieldKeys && currentFieldKeys.length == 1) {
                          var currentField = widgetChart.x_axis[currentFieldKeys[0]];
                          return Func.formatNumByUnitAndThoundth(params.value, currentField.show_type.thousandth, currentField.show_type.unit, currentField.show_type.compose);
                        } else {
                          return params.value;
                        }
                      }
                    }
                  }
                }]
              };
            });
          } else if (values_title.title == 'x_all') {
            _.forEach(option.series, function (seriesData) {
              seriesData.label = {
                normal: {
                  show: true,
                  formatter: function formatter(params) {
                    if (params.value.length) {
                      var currentFieldKeys = _.keys(widgetChart.x_axis);
                      if (currentFieldKeys && currentFieldKeys.length == 1) {
                        var currentField = widgetChart.x_axis[currentFieldKeys[0]];
                        return Func.formatNumByUnitAndThoundth(params.value[0], currentField.show_type.thousandth, currentField.show_type.unit, currentField.show_type.compose);
                      } else {
                        return params.value[0];
                      }
                    } else {
                      return '';
                    }
                  }
                }
              };
            });
          } else if (values_title.title == 'y_max') {
            _.forEach(option.series, function (seriesData) {
              seriesData.markPoint = {
                data: [{
                  type: 'max',
                  name: '最大值',
                  symbolRotate: rotate,
                  label: {
                    normal: {
                      offset: offset,
                      formatter: function formatter(params) {
                        var currentFieldKeys = _.keys(widgetChart.y_axis);
                        if (currentFieldKeys && currentFieldKeys.length == 1) {
                          var currentField = widgetChart.y_axis[currentFieldKeys[0]];
                          return Func.formatNumByUnitAndThoundth(params.value, currentField.show_type.thousandth, currentField.show_type.unit, currentField.show_type.compose);
                        } else {
                          return params.value;
                        }
                      }
                    }
                  }
                }]
              };
            });
          } else if (values_title.title == 'y_min') {
            _.forEach(option.series, function (seriesData) {
              seriesData.markPoint = {
                data: [{
                  type: 'min',
                  name: '最小值',
                  symbolRotate: rotate,
                  label: {
                    normal: {
                      offset: offset,
                      formatter: function formatter(params) {
                        var currentFieldKeys = _.keys(widgetChart.y_axis);
                        if (currentFieldKeys && currentFieldKeys.length == 1) {
                          var currentField = widgetChart.y_axis[currentFieldKeys[0]];
                          return Func.formatNumByUnitAndThoundth(params.value, currentField.show_type.thousandth, currentField.show_type.unit, currentField.show_type.compose);
                        } else {
                          return params.value;
                        }
                      }
                    }
                  }
                }]
              };
            });
          } else if (values_title.title == 'y_and') {
            _.forEach(option.series, function (seriesData) {
              seriesData.markPoint = {
                data: [{
                  type: 'min',
                  name: '最小值',
                  symbolRotate: rotate,
                  label: {
                    normal: {
                      offset: offset,
                      formatter: function formatter(params) {
                        var currentFieldKeys = _.keys(widgetChart.y_axis);
                        if (currentFieldKeys && currentFieldKeys.length == 1) {
                          var currentField = widgetChart.y_axis[currentFieldKeys[0]];
                          return Func.formatNumByUnitAndThoundth(params.value, currentField.show_type.thousandth, currentField.show_type.unit, currentField.show_type.compose);
                        } else {
                          return params.value;
                        }
                      }
                    }
                  }
                }, {
                  type: 'max',
                  name: '最大值',
                  symbolRotate: rotate,
                  label: {
                    normal: {
                      offset: offset,
                      formatter: function formatter(params) {
                        var currentFieldKeys = _.keys(widgetChart.y_axis);
                        if (currentFieldKeys && currentFieldKeys.length == 1) {
                          var currentField = widgetChart.y_axis[currentFieldKeys[0]];
                          return Func.formatNumByUnitAndThoundth(params.value, currentField.show_type.thousandth, currentField.show_type.unit, currentField.show_type.compose);
                        } else {
                          return params.value;
                        }
                      }
                    }
                  }
                }]
              };
            });
          } else if (values_title.title == 'y_all') {
            _.forEach(option.series, function (seriesData) {
              seriesData.label = {
                normal: {
                  show: true,
                  formatter: function formatter(params) {
                    if (params.value.length) {
                      var currentFieldKeys = _.keys(widgetChart.y_axis);
                      if (currentFieldKeys && currentFieldKeys.length == 1) {
                        var currentField = widgetChart.y_axis[currentFieldKeys[0]];
                        return Func.formatNumByUnitAndThoundth(params.value[1], currentField.show_type.thousandth, currentField.show_type.unit, currentField.show_type.compose);
                      } else {
                        return params.value[1];
                      }
                    } else {
                      return '';
                    }
                  }
                }
              };
            });
          } else if (values_title.title == 'symbol_all') {
            _.forEach(option.series, function (seriesData) {
              seriesData.label = {
                normal: {
                  show: true,
                  formatter: function formatter(params) {
                    if (params.value.length) {
                      if (params.value[2]) {
                        return params.value[2];
                      } else {
                        return '';
                      }
                    } else {
                      return '';
                    }
                  }
                }
              };
            });
          } else if (values_title.title == 'darkness_all') {
            _.forEach(option.series, function (seriesData) {
              seriesData.label = {
                normal: {
                  show: true,
                  formatter: function formatter(params) {
                    if (params.value.length) {
                      if (params.value[3]) {
                        return params.value[3];
                      } else {
                        return '';
                      }
                    } else {
                      return '';
                    }
                  }
                }
              };
            });
          }
        }

        if (section.is_show) {
          _.forEach(option.series, function (seriesData) {
            seriesData.markArea = {
              silent: true,
              itemStyle: {
                normal: {
                  color: 'transparent',
                  borderWidth: 1,
                  borderType: section.line_type
                }
              },
              data: [[{
                xAxis: 'min',
                yAxis: 'min'
              }, {
                xAxis: 'max',
                yAxis: 'max'
              }]]
            };
            if (section.show_title) {
              seriesData.markArea.data[0][0].name = seriesData.name + '\u5206\u5E03\u533A\u95F4';
            }
          });
        }
        if (option.visualMap[0]) {
          option.visualMap[0].show = show_scale.is_symbol_size;
        }
        if (option.visualMap[1]) {
          option.visualMap[1].show = show_scale.is_saturation;
        }

        if (option.visualMap.length) {
          if (option.visualMap[0] && option.visualMap[0].show || option.visualMap[1] && option.visualMap[1].show) {
            option.grid.right = 70;
          }
        }

        option.grid.right = Math.max(9, option.grid.right || 0);

        if (widgetChart && widgetChart.symbol_size && option.visualMap[0]) {
          _.forEach(widgetChart.symbol_size, function (field, fieldKey) {
            if (field && field.compute == 'desc') {
              option.visualMap[0].inRange.symbolSize = [70, 10];
              return false;
            }
          });
        }
        if (widgetChart && widgetChart.saturation && option.visualMap[1]) {
          _.forEach(widgetChart.saturation, function (field, fieldKey) {
            if (field && field.compute == 'desc') {
              option.visualMap[1].inRange.colorLightness = [0.4, 0.9];
              return false;
            }
          });
        }
      } else {
        option.xAxis.name = '';
        option.yAxis.name = '';
      }
      var horizenMarkLabel = [];
      if (widgetAnalyze && widgetAnalyze.markline.length) {
        _.forEach(widgetAnalyze.markline, function (markLine) {
          _.forEach(option.series, function (seriesData) {
            if (markLine.stat_value == seriesData.true_name) {
              var _xAxisData = [];
              var yAxisData = [];
              _.forEach(seriesData.data, function (sdata) {
                _xAxisData.push(sdata[0]);
                yAxisData.push(sdata[1]);
              });
              var maxXAxisNum = _.maxBy(_xAxisData, Number);
              var minXAxisNum = _.minBy(_xAxisData, Number);
              var averageXAxisNum = _.sumBy(_xAxisData, Number) / _xAxisData.length;
              var maxYAxisNum = _.maxBy(yAxisData, Number);
              var minYAxisNum = _.minBy(yAxisData, Number);
              var averageYAxisNum = _.sumBy(yAxisData, Number) / yAxisData.length;
              if (markLine.direction == 'vertical') {
                var showType = null;
                if (widgetChart.x_axis) {
                  var xKeys = _.keys(widgetChart.x_axis);
                  if (xKeys.length == 1) {
                    showType = widgetChart.x_axis[xKeys[0]].show_type;
                  }
                }
                var markLineOption = {};
                if (markLine.type == 'avg') {
                  markLineOption.xAxis = averageXAxisNum;
                } else if (markLine.type == 'max') {
                  markLineOption.xAxis = maxXAxisNum;
                } else if (markLine.type == 'min') {
                  markLineOption.xAxis = minXAxisNum;
                }
                markLineOption.name = markLine.title;
                if (markLine.line_color) {
                  markLineOption.lineStyle = {
                    normal: {
                      color: markLine.line_color,
                      type: markLine.line_type
                    }
                  };
                }
                var formatterTxt = '';
                var showVal = '';
                if (markLine.type == 'avg') {
                  if (showType) {
                    if (showType.decimal) {
                      if (parseInt(showType.decimal)) {
                        averageXAxisNum = averageXAxisNum.toFixed(parseInt(showType.decimal));
                      }
                    }
                    showVal = Func.formatNumByUnitAndThoundth(averageXAxisNum, showType.thousandth, showType.unit, showType.compose);
                  } else {
                    showVal = averageXAxisNum;
                  }
                } else if (markLine.type == 'max') {
                  if (showType) {
                    showVal = Func.formatNumByUnitAndThoundth(maxXAxisNum, showType.thousandth, showType.unit, showType.compose);
                  } else {
                    showVal = maxXAxisNum;
                  }
                } else if (markLine.type == 'min') {
                  if (showType) {
                    showVal = Func.formatNumByUnitAndThoundth(minXAxisNum, showType.thousandth, showType.unit, showType.compose);
                  } else {
                    showVal = minXAxisNum;
                  }
                }
                if (markLine.show == 'valuetitle') {
                  option.grid.top = 30;
                  markLineOption.label = {
                    normal: {
                      show: true,
                      formatter: ''
                    }
                  };
                  formatterTxt = markLine.title + '\uFF1A' + showVal;
                  markLineOption.label.normal.formatter = formatterTxt;
                } else if (markLine.show == 'title') {
                  option.grid.top = 30;
                  formatterTxt = markLine.title;
                  markLineOption.label = {
                    normal: {
                      show: true,
                      formatter: formatterTxt
                    }
                  };
                } else if (markLine.show == 'value') {
                  option.grid.top = 30;
                  markLineOption.label = {
                    normal: {
                      show: true,
                      formatter: showVal
                    }
                  };
                } else if (markLine.show == 'none') {
                  markLineOption.label = {
                    normal: {
                      show: false
                    }
                  };
                }

                if (seriesData.markLine && seriesData.markLine.data && seriesData.markLine.data.length) {
                  seriesData.markLine.data.push(markLineOption);
                } else {
                  seriesData.markLine = {
                    data: [markLineOption]
                  };
                }
              } else {
                var _showType = null;
                if (widgetChart.y_axis) {
                  var yKeys = _.keys(widgetChart.y_axis);
                  if (yKeys.length == 1) {
                    _showType = widgetChart.y_axis[yKeys[0]].show_type;
                  }
                }
                var _formatterTxt = '';
                var _showVal = '';
                if (markLine.type == 'avg') {
                  if (_showType) {
                    if (_showType.decimal) {
                      if (parseInt(_showType.decimal)) {
                        averageYAxisNum = averageYAxisNum.toFixed(parseInt(_showType.decimal));
                      }
                    }
                    _showVal = Func.formatNumByUnitAndThoundth(averageYAxisNum, _showType.thousandth, _showType.unit, _showType.compose);
                  } else {
                    _showVal = averageYAxisNum;
                  }
                } else if (markLine.type == 'max') {
                  if (_showType) {
                    _showVal = Func.formatNumByUnitAndThoundth(maxYAxisNum, _showType.thousandth, _showType.unit, _showType.compose);
                  } else {
                    _showVal = maxYAxisNum;
                  }
                } else if (markLine.type == 'min') {
                  if (_showType) {
                    _showVal = Func.formatNumByUnitAndThoundth(minYAxisNum, _showType.thousandth, _showType.unit, _showType.compose);
                  } else {
                    _showVal = minYAxisNum;
                  }
                }
                var _markLineOption = {
                  type: markLine.type == 'avg' ? 'average' : markLine.type,
                  name: markLine.title
                };
                if (markLine.line_color) {
                  _markLineOption.lineStyle = {
                    normal: {
                      color: markLine.line_color,
                      type: markLine.line_type
                    }
                  };
                }
                if (markLine.show == 'valuetitle') {
                  _formatterTxt = markLine.title + '\uFF1A' + _showVal;
                  _markLineOption.label = {
                    normal: {
                      position: 'end',
                      formatter: _formatterTxt
                    }
                  };
                } else if (markLine.show == 'title') {
                  _formatterTxt = markLine.title;
                  _markLineOption.label = {
                    normal: {
                      position: 'end',
                      formatter: _formatterTxt
                    }
                  };
                } else if (markLine.show == 'none') {
                  _markLineOption.label = {
                    normal: {
                      show: false
                    }
                  };
                } else if (markLine.show == 'value') {
                  _formatterTxt = _showVal;
                  _markLineOption.label = {
                    normal: {
                      position: 'end',
                      formatter: _formatterTxt
                    }
                  };
                }

                horizenMarkLabel.push(Func.getStrWidthByFontSize(_formatterTxt));

                if (seriesData.markLine && seriesData.markLine.data && seriesData.markLine.data.length) {
                  seriesData.markLine.data.push(_markLineOption);
                } else {
                  seriesData.markLine = {
                    data: [_markLineOption]
                  };
                }
              }
            }
          });
        });
      }
      if (horizenMarkLabel.length) {
        var maxMarkLineLabelLength = _.max(horizenMarkLabel);
        var _right = 9 + maxMarkLineLabelLength;
        if (option.visualMap[0] && option.visualMap[0].show || option.visualMap[1] && option.visualMap[1].show) {
          if (_right < 70) {
            _right = 70;
          }
        }
        option.grid.right = _right;
      }

      option.tooltip = {
        showDelay: 0,
        formatter: function formatter(params) {
          var ret = '';
          if (_.isArray(params.value) && params.value.length > 1 && xShowType && yShowType) {
            var xFormatVal = Func.formatNumByUnitAndThoundth(params.value[0], xShowType.thousandth, xShowType.unit, xShowType.compose);
            var yFormatVal = Func.formatNumByUnitAndThoundth(params.value[1], yShowType.thousandth, yShowType.unit, yShowType.compose);
            ret = params.seriesName + '<br/>' + data.xAxis.name + '：' + xFormatVal + '<br/>' + data.yAxis.name + '：' + yFormatVal;
            if (params.value[2]) {
              var symbolVal = params.value[2];
              if (showTypeConfigs[2]) {
                symbolVal = Func.formatNumByUnitAndThoundth(symbolVal, showTypeConfigs[2].thousandth, showTypeConfigs[2].unit, showTypeConfigs[2].compose);
              }
              ret += '<br/>' + data.symbol_size.name + '：' + symbolVal;
            }
            if (params.value[3]) {
              var saturationVal = params.value[3];
              if (showTypeConfigs[3]) {
                saturationVal = Func.formatNumByUnitAndThoundth(saturationVal, showTypeConfigs[3].thousandth, showTypeConfigs[3].unit, showTypeConfigs[3].compose);
              }
              ret += '<br/>' + data.saturation.name + '：' + saturationVal;
            }
          } else {
            ret = params.seriesName + '<br/>' + params.name + '：' + params.value;
          }
          return ret;
        },
        textStyle: {
          fontSize: 12
        }
      };
      break;
    case 'single':
      var seriesSetting = {};
      if (widgetStyle && widgetStyle.trend_chart) {
        seriesSetting.lineStyle = {
          normal: {
            color: widgetStyle.trend_chart.color
          }
        };

        seriesSetting.itemStyle = {
          normal: {
            color: widgetStyle.trend_chart.color
          }
        };

        if (widgetStyle.trend_chart.line_type == 'curve') {
          seriesSetting.smooth = true;
        } else if (widgetStyle.trend_chart.line_type == 'step') {
          seriesSetting.step = 'start';
        } else {
          seriesSetting.step = null;
          seriesSetting.smooth = false;
        }
      } else if (data && data.series) {
        seriesSetting.lineStyle = {
          normal: {
            color: '#5BA778'
          }
        };
        seriesSetting.itemStyle = {
          normal: {
            color: '#5BA778'
          }
        };
      }

      var left = 0;
      var right = 0;

      if (data.series[0].type == 'area') {
        seriesSetting.type = 'line';
        seriesSetting.areaStyle = {
          normal: {
            opacity: 0.4
          }
        };
      }

      if (data.series[0].type == 'bar') {
        left = 5;
        right = 5;
      }

      var xAxis = [];
      if (data.xAxis) {
        var newData = [];
        if (_.get(data, 'xAxis.data')) {
          _.forEach(data.xAxis.data, function (single) {
            newData.push(single.value);
          });
        }

        var boundaryGap = false;
        if (data.series[0].type == 'bar') {
          boundaryGap = true;
        }

        xAxis = [{
          type: 'category',
          show: false,
          boundaryGap: boundaryGap,
          axisTick: {
            show: true,
            alignWithLabel: true
          },
          data: newData
        }];
      }

      var yAxis = [];
      if (data.yAxis) {
        yAxis = [_.extend(data.yAxis, { show: false })];
      } else {
        yAxis = [{ show: false }];
      }

      var valueConfig = _.last(_.values(widgetChart.value_config));

      option = {
        series: [_.extend({}, data.series[0], seriesSetting)],
        xAxis: xAxis,
        yAxis: yAxis,
        grid: {
          left: left,
          right: right,
          bottom: 0,
          top: 10,
          containLabel: false
        }
      };

      option.tooltip = {
        trigger: 'axis',
        textStyle: {
          fontSize: 12
        },
        axisPointer: {
          type: 'line' },
        position: function position(point, params, dom) {
          return ['10%', '10%'];
        },
        formatter: function formatter(params) {
          if (params.length) {
            var ret = params[0].axisValueLabel + '：';
            _.forEach(params, function (chartConfig, index) {
              var showType = valueConfig.show_type;
              var valueFormat = '';
              switch (showType.value_format) {
                case 'percent':
                  valueFormat = '%';
                  break;
                case 'permille':
                  valueFormat = '‰';
                  break;
                case 'thousand':
                  valueFormat = 'K';
                  break;
                case 'ten_thousand':
                  valueFormat = '万';
                  break;
                case 'million':
                  valueFormat = 'M';
                  break;
                case 'ten_million':
                  valueFormat = '亿';
                  break;
              }
              var formatVal = Func.formatNumByUnitAndThoundth(chartConfig.value, showType.thousandth, showType.unit, showType.compose, valueFormat);
              ret = ret + '<br/>' + chartConfig.seriesName + '：' + formatVal;
            });
            return ret;
          } else {
            return '';
          }
        }
      };
      break;
    case 'line':
    case 'area':
    case 'bar':
    case 'bar_y':
      if (data.xAxis && data.xAxis.data) {
        _.forEach(data.xAxis.data, function (value, key) {
          if (value) {
            xAxisData.push(value.value);
          }
        });
      }

      option = {
        xAxis: {
          type: 'category',
          data: xAxisData,
          nameLocation: 'middle',
          nameGap: 30,
          axisTick: {
            show: true,
            alignWithLabel: true
          }
        },
        grid: {
          left: 10,
          right: 9,
          bottom: 10,
          top: 20,
          containLabel: true
        },
        yAxis: _.extend({}, data.yAxis, {
          axisTick: {
            show: true,
            alignWithLabel: true
          }
        }),
        series: _.cloneDeep(data.series)
      };

      _.forEach(widgetChart.y_axis, function (yField) {
        showTypeConfigs.push(yField.show_type);
        showTypeJsonConfigs.push(JSON.stringify(yField.show_type));
      });

      if (chartType == 'area') {
        _.forEach(option.series, function (seriesData) {
          seriesData.areaStyle = { normal: { opacity: 0.2 } };
          if (widgetStyle && widgetStyle.line_color.length) {
            var filterColor = _.find(widgetStyle.line_color, function (licolor) {
              return licolor.true_name == seriesData.true_name;
            });
            if (filterColor) {
              seriesData.areaStyle.normal.color = filterColor.color;
            }
          }
        });
      }
      if (widgetStyle && !_.isEmpty(data.legend)) {
        var _defaultColors2 = MULTIPLE_COLORS_GRADIENT[1];
        if (!_.isEmpty(widgetStyle.colorSeries)) {
          _defaultColors2 = widgetStyle.colorSeries;
        }
        var _loopIndex2 = 0;

        _.forEach(data.series, function (seriesData, index) {
          var filterField = _.find(widgetStyle.line_color, function (lineColor) {
            return lineColor.true_name == seriesData.true_name;
          });
          if (!_defaultColors2[_loopIndex2]) {
            _loopIndex2 = 0;
          }
          if (filterField) {
            colors.push(filterField.color);
          } else {
            colors.push(_defaultColors2[_loopIndex2]);
          }
          _loopIndex2++;
        });
      } else {
        var _defaultColors3 = MULTIPLE_COLORS_GRADIENT[1];
        if (widgetStyle && !_.isEmpty(widgetStyle.colorSeries)) {
          _defaultColors3 = widgetStyle.colorSeries;
        }
        if (!_.isEmpty(data.legend)) {
          var _loopIndex3 = 0;
          _.forEach(data.legend, function (legendData) {
            if (!_defaultColors3[_loopIndex3]) {
              _loopIndex3 = 0;
            }
            colors.push(_defaultColors3[_loopIndex3]);
            _loopIndex3++;
          });
        }
      }

      if (chartType == 'bar_y') {
        option.xAxis.type = 'value';
        option.xAxis.axisLabel = {
          formatter: function formatter(value, index) {
            if (widgetStyle && widgetStyle.graph && widgetStyle.graph.type == 'percent') {
              return value + '%';
            }
            if (_.uniq(showTypeJsonConfigs).length == 1) {
              var showType = showTypeConfigs[0];
              var retVal = Func.formatNumByUnitAndThoundth(value, showType.thousandth, showType.unit, showType.compose);
              if (widgetChart && widgetChart.y_axis) {
                var yFieldKeys = _.keys(widgetChart.y_axis);
                if (yFieldKeys.length == 1) {
                  var yField = widgetChart.y_axis[yFieldKeys[0]];
                  if (yField && yField.compare) {
                    if (yField.compare.field_id && yField.compare.type && yField.compare.value && yField.compare.value == 'incr_ratio') {
                      retVal = value + '%';
                    }
                  }
                }
              }
              return retVal;
            } else {
              return value;
            }
          }
        };
      } else {
        option.yAxis.axisLabel = {
          formatter: function formatter(value, index) {
            if (_.uniq(showTypeJsonConfigs).length == 1) {
              var showType = showTypeConfigs[0];
              var retVal = Func.formatNumByUnitAndThoundth(value, showType.thousandth, showType.unit, showType.compose);
              if (widgetChart && widgetChart.y_axis) {
                var yFieldKeys = _.keys(widgetChart.y_axis);
                if (yFieldKeys.length == 1) {
                  var yField = widgetChart.y_axis[yFieldKeys[0]];
                  if (yField && yField.compare) {
                    if (yField.compare.field_id && yField.compare.type && yField.compare.value && yField.compare.value == 'incr_ratio') {
                      retVal = value + '%';
                    }
                  }
                }
              }
              return retVal;
            } else {
              return value;
            }
          }
        };
      }

      if (widgetStyle) {
        var _x_axis = widgetStyle.x_axis,
            _y_axis = widgetStyle.y_axis,
            graph = widgetStyle.graph,
            valueTitle = widgetStyle.values_title;

        if (_x_axis.is_show) {
          option.xAxis.show = true;
        } else {
          option.xAxis.show = false;
          option.grid.bottom = -8;
        }
        if (_x_axis.max) {
          option.xAxis.max = _x_axis.max;
        }
        if (_x_axis.min) {
          option.xAxis.min = _x_axis.min;
        }
        if (_x_axis.is_show && _x_axis.show_title) {
          option.xAxis.name = data.xAxis.name;
          option.grid.bottom = Math.max(30, option.grid.bottom || 0);
        } else {
          option.xAxis.name = '';
        }
        if (_y_axis.max) {
          option.yAxis.max = _y_axis.max;
        } else {
          if (graph.type == 'percent') {
            if (chartType == 'bar_y') {
              option.xAxis.max = '100';
            } else {
              option.yAxis.max = '100';
            }
          }
        }
        if (_y_axis.min) {
          option.yAxis.min = _y_axis.min;
        }
        if (_y_axis.is_show) {
          option.yAxis.show = true;
        } else {
          option.yAxis.show = false;
          option.grid.left = -32;
        }
        if (_y_axis.is_show && _y_axis.show_title) {
          option.yAxis.name = data.yAxis.name;
          option.grid.top = Math.max(30, option.grid.top || 0);
        } else {
          option.yAxis.name = '';
        }
        if (graph.line_type == 'curve') {
          _.forEach(option.series, function (value) {
            value.smooth = true;
          });
        } else if (graph.line_type == 'step') {
          _.forEach(option.series, function (value) {
            value.step = 'start';
          });
        }
        if (graph.type == 'stack') {
          _.forEach(option.series, function (value) {
            value.stack = '总量';
          });
        } else if (graph.type == 'percent') {
          if (chartType !== 'bar_y') {
            option.yAxis.axisLabel = {
              formatter: '{value}%'
            };
          }
          _.forEach(option.series, function (value) {
            value.stack = '百分比';
          });
        }
        if (valueTitle && valueTitle.is_show) {
          var _rotate = '0';
          var _offset = [0, 0];
          if (valueTitle.position == 'left') {
            _rotate = '90';
            _offset = [-5, 5];
          } else if (valueTitle.position == 'bottom') {
            _rotate = '180';
            _offset = [0, 10];
          } else if (valueTitle.position == 'right') {
            _rotate = '270';
            _offset = [5, 5];
          }
          if (chartType == 'bar_y') {
            _rotate = '270', _offset = [5, 5];
          }
          if (chartType == 'bar') {
            _rotate = '0', _offset = [0, 0];
          }
          if (valueTitle.title == 'all') {
            _.forEach(option.series, function (seriesData, index) {
              seriesData.label = {
                normal: {
                  show: true,
                  position: valueTitle.position,
                  formatter: function formatter(params) {
                    var showType = null;
                    var currentFieldKey = seriesData.field_key;
                    var yAxisFields = widgetChart.y_axis;
                    var isCompareRatio = false;
                    if (yAxisFields[currentFieldKey]) {
                      var currentField = yAxisFields[currentFieldKey];
                      showType = currentField.show_type;
                      if (currentField && currentField.compare && currentField.compare.field_id && currentField.compare.type && currentField.compare.value == 'incr_ratio') {
                        isCompareRatio = true;
                      }
                    }
                    if (showType) {
                      if (isCompareRatio) {
                        return Func.formatNumByUnitAndThoundth(params.value, showType.thousandth, '%', 'suffix');
                      } else {
                        return Func.formatNumByUnitAndThoundth(params.value, showType.thousandth, showType.unit, showType.compose);
                      }
                    } else {
                      if (isCompareRatio) {
                        return params.value + '%';
                      } else {
                        return params.value;
                      }
                    }
                  }
                }
              };
            });
          } else if (valueTitle.title == 'max') {
            option.grid.top = 40;
            _.forEach(option.series, function (seriesData, index) {
              seriesData.markPoint = {
                data: [{
                  type: 'max',
                  name: '最大值',
                  symbolRotate: _rotate,
                  label: {
                    normal: {
                      offset: _offset,
                      formatter: function formatter(value) {
                        var showType = null;
                        var currentFieldKey = seriesData.field_key;
                        var yAxisFields = widgetChart.y_axis;
                        var isCompareRatio = false;
                        if (yAxisFields[currentFieldKey]) {
                          var currentField = yAxisFields[currentFieldKey];
                          showType = currentField.show_type;
                          if (currentField && currentField.compare && currentField.compare.field_id && currentField.compare.type && currentField.compare.value == 'incr_ratio') {
                            isCompareRatio = true;
                          }
                        }
                        if (showType) {
                          if (isCompareRatio) {
                            return Func.formatNumByUnitAndThoundth(value.value, showType.thousandth, '%', 'suffix');
                          } else {
                            return Func.formatNumByUnitAndThoundth(value.value, showType.thousandth, showType.unit, showType.compose);
                          }
                        } else {
                          if (isCompareRatio) {
                            return value.value + '%';
                          } else {
                            return value.value;
                          }
                        }
                      }
                    }
                  }
                }]
              };
            });
          } else if (valueTitle.title == 'min') {
            _.forEach(option.series, function (seriesData, index) {
              seriesData.markPoint = {
                data: [{
                  type: 'min',
                  name: '最小值',
                  symbolRotate: _rotate,
                  label: {
                    normal: {
                      offset: _offset,
                      formatter: function formatter(value) {
                        var showType = null;
                        var currentFieldKey = seriesData.field_key;
                        var yAxisFields = widgetChart.y_axis;
                        var isCompareRatio = false;
                        if (yAxisFields[currentFieldKey]) {
                          var currentField = yAxisFields[currentFieldKey];
                          showType = currentField.show_type;
                          if (currentField && currentField.compare && currentField.compare.field_id && currentField.compare.type && currentField.compare.value == 'incr_ratio') {
                            isCompareRatio = true;
                          }
                        }
                        if (showType) {
                          if (isCompareRatio) {
                            return Func.formatNumByUnitAndThoundth(value.value, showType.thousandth, '%', 'suffix');
                          } else {
                            return Func.formatNumByUnitAndThoundth(value.value, showType.thousandth, showType.unit, showType.compose);
                          }
                        } else {
                          if (isCompareRatio) {
                            return value.value + '%';
                          } else {
                            return value.value;
                          }
                        }
                      }
                    }
                  }
                }]
              };
            });
          } else if (valueTitle.title == 'and') {
            option.grid.top = 40;
            _.forEach(option.series, function (seriesData, index) {
              seriesData.markPoint = {
                data: [{
                  type: 'max',
                  name: '最大值',
                  symbolRotate: _rotate,
                  label: {
                    normal: {
                      offset: _offset,
                      formatter: function formatter(value) {
                        var showType = null;
                        var currentFieldKey = seriesData.field_key;
                        var yAxisFields = widgetChart.y_axis;
                        var isCompareRatio = false;
                        if (yAxisFields[currentFieldKey]) {
                          var currentField = yAxisFields[currentFieldKey];
                          showType = currentField.show_type;
                          if (currentField && currentField.compare && currentField.compare.field_id && currentField.compare.type && currentField.compare.value == 'incr_ratio') {
                            isCompareRatio = true;
                          }
                        }
                        if (showType) {
                          if (isCompareRatio) {
                            return Func.formatNumByUnitAndThoundth(value.value, showType.thousandth, '%', 'suffix');
                          } else {
                            return Func.formatNumByUnitAndThoundth(value.value, showType.thousandth, showType.unit, showType.compose);
                          }
                        } else {
                          if (isCompareRatio) {
                            return value.value + '%';
                          } else {
                            return value.value;
                          }
                        }
                      }
                    }
                  }
                }, {
                  type: 'min',
                  name: '最小值',
                  symbolRotate: _rotate,
                  label: {
                    normal: {
                      offset: _offset,
                      formatter: function formatter(value) {
                        var showType = null;
                        var currentFieldKey = seriesData.field_key;
                        var yAxisFields = widgetChart.y_axis;
                        var isCompareRatio = false;
                        if (yAxisFields[currentFieldKey]) {
                          var currentField = yAxisFields[currentFieldKey];
                          showType = currentField.show_type;
                          if (currentField && currentField.compare && currentField.compare.field_id && currentField.compare.type && currentField.compare.value == 'incr_ratio') {
                            isCompareRatio = true;
                          }
                        }
                        if (showType) {
                          if (isCompareRatio) {
                            return Func.formatNumByUnitAndThoundth(value.value, showType.thousandth, '%', 'suffix');
                          } else {
                            return Func.formatNumByUnitAndThoundth(value.value, showType.thousandth, showType.unit, showType.compose);
                          }
                        } else {
                          if (isCompareRatio) {
                            return value.value + '%';
                          } else {
                            return value.value;
                          }
                        }
                      }
                    }
                  }
                }]
              };
            });
          }
        }
      } else {
        option.xAxis.name = '';
        option.yAxis.name = '';
      }
      if (widgetAnalyze && widgetAnalyze.markline.length) {
        _.forEach(widgetAnalyze.markline, function (markLine) {
          _.forEach(option.series, function (seriesData, index) {
            var maxNumber = _.maxBy(seriesData.data, Number);
            var minNumber = _.minBy(seriesData.data, Number);
            var averageNumber = _.sumBy(seriesData.data, Number) / seriesData.data.length;
            if (markLine.stat_value == seriesData.true_name) {
              var showNumber = void 0;
              var formatTxt = '';
              var showType = null;
              var isCompareRatio = false;
              if (widgetChart && widgetChart.y_axis) {
                var filterField = _.find(widgetChart.y_axis, function (yField) {
                  return yField.field_key == seriesData.field_key;
                });
                if (filterField && filterField.show_type) {
                  showType = filterField.show_type;
                }
                if (filterField && filterField.compare && filterField.compare.field_id && filterField.compare.type && filterField.compare.value == 'incr_ratio') {
                  isCompareRatio = true;
                }
              }
              if (markLine.type == 'avg') {
                if (showType) {
                  var decimal = _.parseInt(showType.decimal);
                  if (_.isNumber(decimal) && !_.isNaN(decimal)) {
                    averageNumber = averageNumber.toFixed(decimal);
                  }
                  if (isCompareRatio) {
                    showNumber = Func.formatNumByUnitAndThoundth(averageNumber, showType.thousandth, '%', 'suffix');
                  } else {
                    showNumber = Func.formatNumByUnitAndThoundth(averageNumber, showType.thousandth, showType.unit, showType.compose);
                  }
                } else {
                  if (isCompareRatio) {
                    showNumber = averageNumber + '%';
                  } else {
                    showNumber = averageNumber;
                  }
                }
              } else if (markLine.type == 'max') {
                if (showType) {
                  if (isCompareRatio) {
                    showNumber = Func.formatNumByUnitAndThoundth(maxNumber, showType.thousandth, '%', 'suffix');
                  } else {
                    showNumber = Func.formatNumByUnitAndThoundth(maxNumber, showType.thousandth, showType.unit, showType.compose);
                  }
                } else {
                  if (isCompareRatio) {
                    showNumber = maxNumber + '%';
                  } else {
                    showNumber = maxNumber;
                  }
                }
              } else {
                if (showType) {
                  if (isCompareRatio) {
                    showNumber = Func.formatNumByUnitAndThoundth(minNumber, showType.thousandth, '%', 'suffix');
                  } else {
                    showNumber = Func.formatNumByUnitAndThoundth(minNumber, showType.thousandth, showType.unit, showType.compose);
                  }
                } else {
                  showNumber = minNumber;
                }
              }
              var markLineOption = {
                type: markLine.type == 'avg' ? 'average' : markLine.type,
                name: markLine.title
              };
              if (markLine.line_color) {
                markLineOption.lineStyle = {
                  normal: {
                    color: markLine.line_color,
                    type: markLine.line_type
                  }
                };
              }
              if (markLine.show == 'valuetitle') {
                formatTxt = markLine.title + '\uFF1A' + showNumber;
                markLineOption.label = {
                  normal: {
                    position: 'end',
                    formatter: formatTxt
                  }
                };
              } else if (markLine.show == 'title') {
                formatTxt = markLine.title;
                markLineOption.label = {
                  normal: {
                    position: 'end',
                    formatter: formatTxt
                  }
                };
              } else if (markLine.show == 'none') {
                markLineOption.label = {
                  normal: {
                    show: false
                  }
                };
              } else {
                formatTxt = showNumber;
                markLineOption.label = {
                  normal: {
                    position: 'end',
                    formatter: formatTxt
                  }
                };
              }
              if (formatTxt) {
                if (chartType == 'bar_y') {
                  option.grid.top = 20;
                } else {
                  var formatTxtShowLength = Func.getStrWidthByFontSize(formatTxt);
                  var rightNum = 9 + formatTxtShowLength;
                  if (option.grid.right < rightNum) {
                    option.grid.right = rightNum;
                  }
                }
              }
              var newSeriesData = void 0;
              if (seriesData.markLine && seriesData.markLine.data && seriesData.markLine.data.length) {
                var filterLine = seriesData.markLine.data.concat(markLineOption);
                var newMarkLine = _.extend({}, seriesData.markLine, { data: filterLine });
                newSeriesData = _.extend({}, seriesData, { markLine: newMarkLine });
              } else {
                var _filterLine = { data: [markLineOption] };
                newSeriesData = _.extend({}, seriesData, { markLine: _filterLine });
              }
              option.series.splice(index, 1, newSeriesData);
            }
          });
        });
      }

      option.tooltip = {
        trigger: 'axis',
        textStyle: {
          fontSize: 12
        },
        formatter: function formatter(params) {
          if (params.length) {
            var ret = params[0].axisValueLabel;
            var compareTxt = '';
            var isPercentStack = false;
            if (widgetStyle) {
              if (widgetStyle.graph && widgetStyle.graph.type == 'percent') {
                isPercentStack = true;
              }
            }
            _.forEach(params, function (chartConfig) {
              var formatVal = '';
              var showType = null;
              var seriesName = chartConfig.seriesName;
              var filterSeries = _.find(data.series, function (seriesData) {
                return seriesData.name == seriesName;
              });
              var isCompareIncrRatio = false;
              if (filterSeries) {
                var currentFieldKey = filterSeries.field_key;
                if (widgetChart && widgetChart.y_axis && widgetChart.y_axis[currentFieldKey]) {
                  showType = widgetChart.y_axis[currentFieldKey].show_type;
                  if (widgetChart.y_axis[currentFieldKey].compare) {
                    var _widgetChart$y_axis$c = widgetChart.y_axis[currentFieldKey].compare,
                        field_id = _widgetChart$y_axis$c.field_id,
                        type = _widgetChart$y_axis$c.type,
                        value = _widgetChart$y_axis$c.value;

                    if (field_id && type && value == 'incr_ratio') {
                      isCompareIncrRatio = true;
                    }
                  }
                }
              }

              if (chartConfig.value) {
                if (isPercentStack) {
                  formatVal = chartConfig.value + '%';
                } else if (showType) {
                  if (isCompareIncrRatio) {
                    formatVal = Func.formatNumByUnitAndThoundth(chartConfig.value, showType.thousandth, '%', 'suffix');
                  } else {
                    formatVal = Func.formatNumByUnitAndThoundth(chartConfig.value, showType.thousandth, showType.unit, showType.compose);
                  }
                } else {
                  if (isCompareIncrRatio) {
                    formatVal = chartConfig.value + '%';
                  } else {
                    formatVal = chartConfig.value;
                  }
                }
              } else {
                formatVal = showType && showType.null_value === '0' ? '0' : '--';
              }
              if (filterSeries && filterSeries.is_compare_series) {
                if (data.compare_xAxis && data.compare_xAxis.data) {
                  var compareAxis = data.compare_xAxis.data;
                  if (compareAxis[chartConfig.dataIndex]) {
                    var filterName = compareAxis[chartConfig.dataIndex].value;
                    if (filterName) {
                      if (compareTxt) {
                        compareTxt = compareTxt + '<br/>' + chartConfig.seriesName + '：' + formatVal;
                      } else {
                        compareTxt = filterName + '<br/>' + chartConfig.seriesName + '：' + formatVal;
                      }
                    } else {
                      if (compareTxt) {
                        compareTxt = compareTxt + '<br/>' + chartConfig.seriesName + '：' + formatVal;
                      } else {
                        compareTxt = chartConfig.seriesName + '：' + formatVal;
                      }
                    }
                  }
                }
              } else {
                ret = ret + '<br/>' + chartConfig.seriesName + '：' + formatVal;
              }
            });
            if (compareTxt) {
              return ret + '<br/>' + compareTxt;
            }
            return ret;
          } else {
            return '';
          }
        }
      };
      break;
    case 'funnel':
      var color = _.get(widgetStyle, 'color', TWO_COLORS_GRADIENT[1]);

      var startColor = parseColor(color[0]);
      var endColor = parseColor(color[1]);
      var number = !_.isEmpty(data.series[0].data) ? data.series[0].data.length : 0;
      var r = Math.round((endColor[0] - startColor[0]) / number);
      var g = Math.round((endColor[1] - startColor[1]) / number);
      var b = Math.round((endColor[2] - startColor[2]) / number);

      for (var i = number; i >= 0; i--) {
        colors.push('rgb(' + (r * i + startColor[0]) + ', ' + (g * i + startColor[1]) + ', ' + (b * i + startColor[2]) + ')');
      }

      var seriesData = data.series[0].data;

      if (!_.isEmpty(seriesData)) {
        seriesData.forEach(function (series, index) {
          var dataColor = {
            type: 'linear',
            x: 0,
            y: 0,
            x2: 0,
            y2: 1,
            colorStops: [{
              offset: 0, color: colors[index]
            }, {
              offset: 1, color: colors[index + 1]
            }],
            globalCoord: false
          };

          if (sortBy === 'value' && sortType === 'ASC') {
            dataColor.colorStops.reverse();
          }

          series.itemStyle = {
            normal: {
              color: dataColor
            }
          };
        });
      }

      var _data$sort = data.sort,
          sortBy = _data$sort.sort_by,
          sortType = _data$sort.sort_type;

      var sort = void 0;
      if (sortBy === 'group' || sortBy === 'none') {
        sort = 'none';
      } else if (sortBy === 'value') {
        if (sortType === 'ASC') {
          sort = 'ascending';
        } else if (sortType === 'DESC') {
          sort = 'descending';
        } else {
          sort = 'none';
        }
      }

      var _toMerge = {
        data: seriesData,
        maxSize: '90%',
        top: 10,
        bottom: 10,
        labelLine: {
          normal: {
            length: 10
          }
        },
        sort: sort
      };

      if (_.get(widgetStyle, 'values_title.is_show')) {
        var nameWidthArr = _.map(data.series[0].data, function (_ref) {
          var name = _ref.name;
          return Func.getStrWidthByFontSize(name + ': 100%');
        });
        var adjustedTitleWidthDuty = Math.min(45, Math.max(20, _.max(nameWidthArr) / (window.innerWidth * 0.009)));

        switch (_.get(widgetStyle, 'values_title.position')) {
          case 'left':
            _toMerge.left = adjustedTitleWidthDuty + '%';
            _toMerge.width = 100 - adjustedTitleWidthDuty + '%';
            break;
          case 'right':
            _toMerge.right = adjustedTitleWidthDuty + '%';
            _toMerge.width = 100 - adjustedTitleWidthDuty + '%';
            break;
        }
      }

      option.series = [_.extend({}, data.series[0], _toMerge)];

      if (widgetChart && widgetChartValue) {
        option.tooltip = {
          trigger: 'item',
          textStyle: {
            fontSize: 12,
            fontWeight: 'normal'
          },
          formatter: function formatter(params) {
            if (!_.isEmpty(params)) {
              var value = params.value,
                  name = params.name,
                  percent = params.percent,
                  seriesName = params.seriesName;


              var formatName = name + '<br/>' + seriesName + '\uFF1A';
              var showType = widgetChartValue.show_type;
              var formatVal = '';
              if (value) {
                if (showType) {
                  formatVal = Func.formatNumByUnitAndThoundth(value, showType.thousandth, showType.unit, showType.compose) + ' (' + percent + '%)';
                } else {
                  formatVal = value + ' (' + percent + '%)';
                }
              } else {
                formatVal = showType && showType.null_value === '0' ? '0' : '--';
              }

              return formatName + formatVal;
            } else {
              return '';
            }
          }
        };
      }
      break;
    case 'biaxial':
      if (data.xAxis && data.xAxis.data) {
        _.forEach(data.xAxis.data, function (value, key) {
          if (value) {
            xAxisData.push(value.value);
          }
        });
      }

      var leftJsonShowTypes = [];
      var rightJsonShowTypes = [];
      var legendData = [];
      _.forEach(data.legend, function (leg) {
        return legendData.push(leg.true_name);
      });

      if (widgetChart) {
        _.forEach(widgetChart.l_y_axis, function (lField) {
          if (lField.show_type) {
            showTypeConfigs.push(lField.show_type);
            leftJsonShowTypes.push(JSON.stringify(lField.show_type));
          }
        });
        _.forEach(widgetChart.r_y_axis, function (rField) {
          if (rField.show_type) {
            showTypeConfigs.push(rField.show_type);
            rightJsonShowTypes.push(JSON.stringify(rField.show_type));
          }
        });
      }

      option = {
        xAxis: {
          type: 'category',
          data: xAxisData,
          nameLocation: 'middle',
          nameGap: 30,
          name: data.xAxis.name || '',
          axisTick: {
            show: true,
            alignWithLabel: true
          }
        },
        grid: {
          left: 10,
          right: 9,
          bottom: 10,
          top: 10,
          containLabel: true
        },
        yAxis: [],
        series: _.cloneDeep(data.series)
      };

      if (widgetChart) {
        if (!_.isEmpty(widgetChart.l_y_axis)) {
          option.yAxis.push({
            type: 'value',
            position: 'left',
            axisLabel: {
              formatter: function formatter(value, index) {
                if (widgetStyle && widgetStyle.l_graph.type == 'percent') {
                  return value + '%';
                }
                var leftFieldKeys = _.keys(widgetChart.l_y_axis);

                if (leftFieldKeys.length == 1) {
                  var currentField = widgetChart.l_y_axis[leftFieldKeys[0]];

                  if (currentField.compare && currentField.compare.field_id && currentField.compare.type && currentField.compare.value == 'incr_ratio') {
                    return Func.formatNumByUnitAndThoundth(value, currentField.show_type.thousandth, '%', 'suffix');
                  }
                }

                var showType = showTypeConfigs[0];
                if (_.uniq(leftJsonShowTypes).length == 1) {
                  return Func.formatNumByUnitAndThoundth(value, showType.thousandth, showType.unit, showType.compose);
                } else {
                  return value;
                }
              }
            }
          });
        } else {
          _.forEach(option.series, function (seriesData) {
            seriesData.yAxisIndex = 0;
          });
        }
        if (!_.isEmpty(widgetChart.r_y_axis)) {
          option.yAxis.push({
            type: 'value',
            position: 'right',
            axisLabel: {
              formatter: function formatter(value, index) {
                if (widgetStyle && widgetStyle.r_graph.type == 'percent') {
                  return value + '%';
                }
                var rightFieldKeys = _.keys(widgetChart.r_y_axis);

                if (rightFieldKeys.length == 1) {
                  var currentField = widgetChart.r_y_axis[rightFieldKeys[0]];

                  if (currentField.compare && currentField.compare.field_id && currentField.compare.type && currentField.compare.value == 'incr_ratio') {
                    return Func.formatNumByUnitAndThoundth(value, currentField.show_type.thousandth, '%', 'suffix');
                  } else {
                    var showType = currentField.show_type;
                    if (showType) {
                      return Func.formatNumByUnitAndThoundth(value, showType.thousandth, showType.unit, showType.compose);
                    } else {
                      return value;
                    }
                  }
                } else {
                  return value;
                }
              }
            }
          });
        }
      }

      if (widgetStyle && widgetStyle.l_line_color.length && !_.isEmpty(data.legend)) {
        var _defaultColors4 = MULTIPLE_COLORS_GRADIENT[1];
        if (!_.isEmpty(widgetStyle.colorSeries)) {
          _defaultColors4 = widgetStyle.colorSeries;
        }
        var _loopIndex4 = 0;
        _.forEach(data.series, function (seriesData) {
          var filterField = _.find(widgetStyle.l_line_color, function (lineColor) {
            return lineColor.true_name == seriesData.true_name;
          });
          if (!_defaultColors4[_loopIndex4]) {
            _loopIndex4 = 0;
          }
          if (filterField) {
            colors.push(filterField.color);
          } else {
            colors.push(_defaultColors4[_loopIndex4]);
          }
          _loopIndex4++;
        });
      } else {
        var _defaultColors5 = MULTIPLE_COLORS_GRADIENT[1];
        if (widgetStyle && !_.isEmpty(widgetStyle.colorSeries)) {
          _defaultColors5 = widgetStyle.colorSeries;
        }
        if (!_.isEmpty(data.legend)) {
          var _loopIndex5 = 0;
          _.forEach(data.legend, function (legendData) {
            if (!_defaultColors5[_loopIndex5]) {
              _loopIndex5 = 0;
            }
            colors.push(_defaultColors5[_loopIndex5]);
            _loopIndex5++;
          });
        }
      }

      if (widgetStyle) {
        var _x_axis2 = widgetStyle.x_axis,
            l_y_axis = widgetStyle.l_y_axis,
            r_y_axis = widgetStyle.r_y_axis,
            l_graph = widgetStyle.l_graph,
            r_graph = widgetStyle.r_graph,
            l_values_title = widgetStyle.l_values_title,
            r_values_title = widgetStyle.r_values_title;

        if (!_x_axis2.show_title) {
          option.xAxis.name = '';
        } else {
          option.grid.bottom = 30;
        }
        var leftYaxisIndex = _.findIndex(option.yAxis, function (config) {
          return config.position == 'left';
        });
        var rightYaxisIndex = _.findIndex(option.yAxis, function (config) {
          return config.position == 'right';
        });
        if (leftYaxisIndex > -1 && data.legend.length) {
          if (l_y_axis.show_title) {
            var filterLeftSeries = _.filter(data.series, function (seriesData) {
              return seriesData.yAxisIndex == 0;
            });
            if (filterLeftSeries && filterLeftSeries.length == 1) {
              option.yAxis[leftYaxisIndex].name = data.legend[leftYaxisIndex].name;
              option.grid.top = Math.max(30, option.grid.top || 0);
            }
          }
          if (l_y_axis.max) {
            option.yAxis[leftYaxisIndex].max = l_y_axis.max;
          }
          if (l_y_axis.min) {
            option.yAxis[leftYaxisIndex].min = l_y_axis.min;
          }
        }
        if (rightYaxisIndex > -1) {
          if (r_y_axis.max) {
            option.yAxis[rightYaxisIndex].max = r_y_axis.max;
          }
          if (r_y_axis.min) {
            option.yAxis[rightYaxisIndex].min = r_y_axis.min;
          }
          if (r_y_axis.show_title) {
            var rightAxisName = '';
            _.forEach(option.series, function (seriesData) {
              if (seriesData.yAxisIndex == 1) {
                rightAxisName = seriesData.name;
                return false;
              }
            });
            var filterRightSeries = _.filter(data.series, function (seriesData) {
              return seriesData.yAxisIndex == 1;
            });
            if (filterRightSeries && filterRightSeries.length == 1) {
              option.yAxis[rightYaxisIndex].name = rightAxisName;
              option.grid.top = Math.max(30, option.grid.top || 0);
            }
          }
        }
        if (l_graph.type == 'stack') {
          _.forEach(option.series, function (seriesData) {
            if (seriesData.yAxisIndex == 0) {
              seriesData.stack = '总量';
            }
          });
        }
        if (l_graph.type == 'percent') {
          _.forEach(option.series, function (seriesData) {
            if (seriesData.yAxisIndex == 0) {
              seriesData.stack = '总量';
            }
          });
        }
        if (l_graph.line_type == 'curve') {
          _.forEach(option.series, function (seriesData) {
            if (seriesData.yAxisIndex == 0) {
              if (seriesData.type == 'line') {
                seriesData.smooth = true;
              }
            }
          });
        }
        if (l_graph.line_type == 'step') {
          _.forEach(option.series, function (seriesData) {
            if (seriesData.yAxisIndex == 0) {
              if (seriesData.type == 'line') {
                seriesData.step = 'start';
              }
            }
          });
        }
        if (r_graph.type == 'stack') {
          _.forEach(option.series, function (seriesData) {
            if (leftYaxisIndex == -1 || seriesData.yAxisIndex == 1) {
              seriesData.stack = '总量';
            }
          });
        }
        if (r_graph.type == 'percent') {
          _.forEach(option.series, function (seriesData) {
            if (leftYaxisIndex == -1 || seriesData.yAxisIndex == 1) {
              seriesData.stack = '百分比';
            }
          });
        }
        if (r_graph.line_type == 'curve') {
          _.forEach(option.series, function (seriesData) {
            if (leftYaxisIndex == -1 || seriesData.yAxisIndex == 1) {
              if (seriesData.type == 'line') {
                seriesData.smooth = true;
              }
            }
          });
        }
        if (r_graph.line_type == 'step') {
          _.forEach(option.series, function (seriesData) {
            if (leftYaxisIndex == -1 || seriesData.yAxisIndex == 1) {
              if (seriesData.type == 'line') {
                seriesData.step = 'start';
              }
            }
          });
        }
        if (l_values_title && l_values_title.is_show) {
          var _rotate2 = '0';
          var _offset2 = [0, 0];
          if (l_values_title.position == 'left') {
            _rotate2 = '90';
            _offset2 = [-5, 5];
          } else if (l_values_title.position == 'bottom') {
            _rotate2 = '180';
            _offset2 = [0, 10];
          } else if (l_values_title.position == 'right') {
            _rotate2 = '270';
            _offset2 = [5, 5];
          }
          if (l_values_title.title == 'all') {
            _.forEach(option.series, function (seriesData) {
              if (seriesData.yAxisIndex == 0) {
                seriesData.label = {
                  normal: {
                    show: true,
                    position: l_values_title.position,
                    formatter: function formatter(params) {
                      var filedKey = seriesData.field_key;
                      var currentField = _.find(widgetChart.l_y_axis, function (lField) {
                        return lField.field_key == filedKey;
                      });
                      if (currentField.compare && currentField.compare.field_id && currentField.compare.type && currentField.compare.value == 'incr_ratio') {
                        return Func.formatNumByUnitAndThoundth(params.value, currentField.show_type.thousandth, '%', 'suffix');
                      } else if (currentField && currentField.show_type) {
                        return Func.formatNumByUnitAndThoundth(params.value, currentField.show_type.thousandth, currentField.show_type.unit, currentField.show_type.compose);
                      } else {
                        return params.value;
                      }
                    }
                  }
                };
              }
            });
          } else if (l_values_title.title == 'max') {
            option.grid.top = 40;
            _.forEach(option.series, function (seriesData) {
              if (seriesData.yAxisIndex == 0) {
                seriesData.markPoint = {
                  data: [{
                    type: 'max',
                    name: '最大值',
                    symbolRotate: _rotate2,
                    label: {
                      normal: {
                        offset: _offset2,
                        formatter: function formatter(params) {
                          var filedKey = seriesData.field_key;
                          var currentField = _.find(widgetChart.l_y_axis, function (lField) {
                            return lField.field_key == filedKey;
                          });
                          if (currentField.compare && currentField.compare.field_id && currentField.compare.type && currentField.compare.value == 'incr_ratio') {
                            return Func.formatNumByUnitAndThoundth(params.value, currentField.show_type.thousandth, '%', 'suffix');
                          } else if (currentField && currentField.show_type) {
                            return Func.formatNumByUnitAndThoundth(params.value, currentField.show_type.thousandth, currentField.show_type.unit, currentField.show_type.compose);
                          } else {
                            return params.value;
                          }
                        }
                      }
                    }
                  }]
                };
              }
            });
          } else if (l_values_title.title == 'min') {
            _.forEach(option.series, function (seriesData) {
              if (seriesData.yAxisIndex == 0) {
                seriesData.markPoint = {
                  data: [{
                    type: 'min',
                    name: '最小值',
                    symbolRotate: _rotate2,
                    label: {
                      normal: {
                        offset: _offset2,
                        formatter: function formatter(params) {
                          var filedKey = seriesData.field_key;
                          var currentField = _.find(widgetChart.l_y_axis, function (lField) {
                            return lField.field_key == filedKey;
                          });
                          if (currentField.compare && currentField.compare.field_id && currentField.compare.type && currentField.compare.value == 'incr_ratio') {
                            return Func.formatNumByUnitAndThoundth(params.value, currentField.show_type.thousandth, '%', 'suffix');
                          } else if (currentField && currentField.show_type) {
                            return Func.formatNumByUnitAndThoundth(params.value, currentField.show_type.thousandth, currentField.show_type.unit, currentField.show_type.compose);
                          } else {
                            return params.value;
                          }
                        }
                      }
                    }
                  }]
                };
              }
            });
          } else if (l_values_title.title == 'and') {
            option.grid.top = 40;
            _.forEach(option.series, function (seriesData) {
              if (seriesData.yAxisIndex == 0) {
                seriesData.markPoint = {
                  data: [{
                    type: 'max',
                    name: '最大值',
                    symbolRotate: _rotate2,
                    label: {
                      normal: {
                        offset: _offset2,
                        formatter: function formatter(params) {
                          var filedKey = seriesData.field_key;
                          var currentField = _.find(widgetChart.l_y_axis, function (lField) {
                            return lField.field_key == filedKey;
                          });
                          if (currentField.compare && currentField.compare.field_id && currentField.compare.type && currentField.compare.value == 'incr_ratio') {
                            return Func.formatNumByUnitAndThoundth(params.value, currentField.show_type.thousandth, '%', 'suffix');
                          }
                          if (currentField && currentField.show_type) {
                            return Func.formatNumByUnitAndThoundth(params.value, currentField.show_type.thousandth, currentField.show_type.unit, currentField.show_type.compose);
                          } else {
                            return params.value;
                          }
                        }
                      }
                    }
                  }, {
                    type: 'min',
                    name: '最小值',
                    symbolRotate: _rotate2,
                    label: {
                      normal: {
                        offset: _offset2,
                        formatter: function formatter(params) {
                          var filedKey = seriesData.field_key;
                          var currentField = _.find(widgetChart.l_y_axis, function (lField) {
                            return lField.field_key == filedKey;
                          });
                          if (currentField.compare && currentField.compare.field_id && currentField.compare.type && currentField.compare.value == 'incr_ratio') {
                            return Func.formatNumByUnitAndThoundth(params.value, currentField.show_type.thousandth, '%', 'suffix');
                          }
                          if (currentField && currentField.show_type) {
                            return Func.formatNumByUnitAndThoundth(params.value, currentField.show_type.thousandth, currentField.show_type.unit, currentField.show_type.compose);
                          } else {
                            return params.value;
                          }
                        }
                      }
                    }
                  }]
                };
              }
            });
          }
        }
        if (r_values_title && r_values_title.is_show) {
          var _rotate3 = '0';
          var _offset3 = [0, 0];
          if (r_values_title.position == 'left') {
            _rotate3 = '90';
            _offset3 = [-5, 5];
          } else if (r_values_title.position == 'bottom') {
            _rotate3 = '180';
            _offset3 = [0, 10];
          } else if (r_values_title.position == 'right') {
            _rotate3 = '270';
            _offset3 = [5, 5];
          }
          if (r_values_title.title == 'all') {
            _.forEach(option.series, function (seriesData) {
              if (leftYaxisIndex == -1 || seriesData.yAxisIndex == 1) {
                seriesData.label = {
                  normal: {
                    show: true,
                    position: r_values_title.position,
                    formatter: function formatter(params) {
                      var filedKey = seriesData.field_key;
                      var currentField = _.find(widgetChart.r_y_axis, function (lField) {
                        return lField.field_key == filedKey;
                      });
                      if (currentField.compare && currentField.compare.field_id && currentField.compare.type && currentField.compare.value == 'incr_ratio') {
                        return Func.formatNumByUnitAndThoundth(params.value, currentField.show_type.thousandth, '%', 'suffix');
                      }
                      if (currentField && currentField.show_type) {
                        return Func.formatNumByUnitAndThoundth(params.value, currentField.show_type.thousandth, currentField.show_type.unit, currentField.show_type.compose);
                      } else {
                        return params.value;
                      }
                    }
                  }
                };
              }
            });
          } else if (r_values_title.title == 'max') {
            option.grid.top = 40;
            _.forEach(option.series, function (seriesData) {
              if (leftYaxisIndex == -1 || seriesData.yAxisIndex == 1) {
                seriesData.markPoint = {
                  data: [{
                    type: 'max',
                    name: '最大值',
                    symbolRotate: _rotate3,
                    label: {
                      normal: {
                        offset: _offset3,
                        formatter: function formatter(params) {
                          var filedKey = seriesData.field_key;
                          var currentField = _.find(widgetChart.r_y_axis, function (lField) {
                            return lField.field_key == filedKey;
                          });
                          if (currentField.compare && currentField.compare.field_id && currentField.compare.type && currentField.compare.value == 'incr_ratio') {
                            return Func.formatNumByUnitAndThoundth(params.value, currentField.show_type.thousandth, '%', 'suffix');
                          }
                          if (currentField && currentField.show_type) {
                            return Func.formatNumByUnitAndThoundth(params.value, currentField.show_type.thousandth, currentField.show_type.unit, currentField.show_type.compose);
                          } else {
                            return params.value;
                          }
                        }
                      }
                    }
                  }]
                };
              }
            });
          } else if (r_values_title.title == 'min') {
            _.forEach(option.series, function (seriesData) {
              if (leftYaxisIndex == -1 || seriesData.yAxisIndex == 1) {
                seriesData.markPoint = {
                  data: [{
                    type: 'min',
                    name: '最小值',
                    symbolRotate: _rotate3,
                    label: {
                      normal: {
                        offset: _offset3,
                        formatter: function formatter(params) {
                          var filedKey = seriesData.field_key;
                          var currentField = _.find(widgetChart.r_y_axis, function (lField) {
                            return lField.field_key == filedKey;
                          });
                          if (currentField.compare && currentField.compare.field_id && currentField.compare.type && currentField.compare.value == 'incr_ratio') {
                            return Func.formatNumByUnitAndThoundth(params.value, currentField.show_type.thousandth, '%', 'suffix');
                          }
                          if (currentField && currentField.show_type) {
                            return Func.formatNumByUnitAndThoundth(params.value, currentField.show_type.thousandth, currentField.show_type.unit, currentField.show_type.compose);
                          } else {
                            return params.value;
                          }
                        }
                      }
                    }
                  }]
                };
              }
            });
          } else if (r_values_title.title == 'and') {
            option.grid.top = 40;
            _.forEach(option.series, function (seriesData) {
              if (leftYaxisIndex == -1 || seriesData.yAxisIndex == 1) {
                seriesData.markPoint = {
                  data: [{
                    type: 'max',
                    name: '最大值',
                    symbolRotate: _rotate3,
                    label: {
                      normal: {
                        offset: _offset3,
                        formatter: function formatter(params) {
                          var filedKey = seriesData.field_key;
                          var currentField = _.find(widgetChart.r_y_axis, function (lField) {
                            return lField.field_key == filedKey;
                          });
                          if (currentField.compare && currentField.compare.field_id && currentField.compare.type && currentField.compare.value == 'incr_ratio') {
                            return Func.formatNumByUnitAndThoundth(params.value, currentField.show_type.thousandth, '%', 'suffix');
                          }
                          if (currentField && currentField.show_type) {
                            return Func.formatNumByUnitAndThoundth(params.value, currentField.show_type.thousandth, currentField.show_type.unit, currentField.show_type.compose);
                          } else {
                            return params.value;
                          }
                        }
                      }
                    }
                  }, {
                    type: 'min',
                    name: '最小值',
                    symbolRotate: _rotate3,
                    label: {
                      normal: {
                        offset: _offset3,
                        formatter: function formatter(params) {
                          var filedKey = seriesData.field_key;
                          var currentField = _.find(widgetChart.r_y_axis, function (lField) {
                            return lField.field_key == filedKey;
                          });
                          if (currentField.compare && currentField.compare.field_id && currentField.compare.type && currentField.compare.value == 'incr_ratio') {
                            return Func.formatNumByUnitAndThoundth(params.value, currentField.show_type.thousandth, '%', 'suffix');
                          }
                          if (currentField && currentField.show_type) {
                            return Func.formatNumByUnitAndThoundth(params.value, currentField.show_type.thousandth, currentField.show_type.unit, currentField.show_type.compose);
                          } else {
                            return params.value;
                          }
                        }
                      }
                    }
                  }]
                };
              }
            });
          }
        }
      } else {
        option.xAxis.name = '';
      }
      if (widgetAnalyze && widgetAnalyze.markline.length) {
        _.forEach(widgetAnalyze.markline, function (markLine) {
          _.forEach(option.series, function (seriesData, index) {
            if (markLine.stat_value == seriesData.true_name) {
              var maxNumber = _.maxBy(seriesData.data, Number);
              var minNumber = _.minBy(seriesData.data, Number);
              var averageNumber = _.sumBy(seriesData.data, Number) / seriesData.data.length;
              var showNumber = void 0;
              var formatTxt = '';
              var showType = null;
              var currentCompare = null;
              if (widgetChart && widgetChart.l_y_axis) {
                var filterField = _.find(widgetChart.l_y_axis, function (yField) {
                  return yField.field_key == seriesData.field_key;
                });
                if (filterField && filterField.show_type) {
                  showType = filterField.show_type;
                  currentCompare = filterField.compare;
                }
              }
              if (!showType || !currentCompare) {
                if (widgetChart && widgetChart.r_y_axis) {
                  var _filterField = _.find(widgetChart.r_y_axis, function (yField) {
                    return yField.field_key == seriesData.field_key;
                  });
                  if (_filterField && _filterField.show_type) {
                    showType = _filterField.show_type;
                    currentCompare = _filterField.compare;
                  }
                }
              }
              var isCompareIncrRatio = currentCompare && currentCompare.field_id && currentCompare.type && currentCompare.value == 'incr_ratio';
              if (markLine.type == 'avg') {
                if (showType) {
                  var decimal = _.parseInt(showType.decimal);
                  if (_.isNumber(decimal) && !_.isNaN(decimal)) {
                    averageNumber = averageNumber.toFixed(decimal);
                  }
                  if (isCompareIncrRatio) {
                    showNumber = Func.formatNumByUnitAndThoundth(averageNumber, showType.thousandth, '%', 'suffix');
                  } else {
                    showNumber = Func.formatNumByUnitAndThoundth(averageNumber, showType.thousandth, showType.unit, showType.compose);
                  }
                } else {
                  if (isCompareIncrRatio) {
                    showNumber = averageNumber + '%';
                  } else {
                    showNumber = averageNumber;
                  }
                }
              } else if (markLine.type == 'max') {
                if (showType) {
                  if (isCompareIncrRatio) {
                    showNumber = Func.formatNumByUnitAndThoundth(maxNumber, showType.thousandth, '%', 'suffix');
                  } else {
                    showNumber = Func.formatNumByUnitAndThoundth(maxNumber, showType.thousandth, showType.unit, showType.compose);
                  }
                } else {
                  if (isCompareIncrRatio) {
                    showNumber = maxNumber + '%';
                  } else {
                    showNumber = maxNumber;
                  }
                }
              } else {
                if (showType) {
                  if (isCompareIncrRatio) {
                    showNumber = Func.formatNumByUnitAndThoundth(minNumber, showType.thousandth, '%', 'suffix');
                  } else {
                    showNumber = Func.formatNumByUnitAndThoundth(minNumber, showType.thousandth, showType.unit, showType.compose);
                  }
                } else {
                  if (isCompareIncrRatio) {
                    showNumber = minNumber + '%';
                  } else {
                    showNumber = minNumber;
                  }
                }
              }
              var markLineOption = {
                type: markLine.type == 'avg' ? 'average' : markLine.type,
                name: markLine.title
              };
              if (markLine.line_color) {
                markLineOption.lineStyle = {
                  normal: {
                    color: markLine.line_color,
                    type: markLine.line_type
                  }
                };
              }
              if (markLine.show == 'valuetitle') {
                formatTxt = markLine.title + '\uFF1A' + showNumber;
                markLineOption.label = {
                  normal: {
                    position: 'end',
                    formatter: formatTxt
                  }
                };
              } else if (markLine.show == 'title') {
                formatTxt = markLine.title;
                markLineOption.label = {
                  normal: {
                    position: 'end',
                    formatter: formatTxt
                  }
                };
              } else if (markLine.show == 'none') {
                formatTxt = '';
                markLineOption.label = {
                  normal: {
                    show: false
                  }
                };
              } else {
                formatTxt = showNumber;
                markLineOption.label = {
                  normal: {
                    position: 'end',
                    formatter: formatTxt
                  }
                };
              }
              if (formatTxt) {
                var formatTxtShowLength = Func.getStrWidthByFontSize(formatTxt);
                var rightNum = 9 + formatTxtShowLength;
                if (option.grid.right < rightNum) {
                  option.grid.right = rightNum;
                }
              }

              var newSeriesData = void 0;
              if (seriesData.markLine && seriesData.markLine.data && seriesData.markLine.data.length) {
                var filterLine = seriesData.markLine.data.concat(markLineOption);
                var newMarkLine = _.extend({}, seriesData.markLine, { data: filterLine });
                newSeriesData = _.extend({}, seriesData, { markLine: newMarkLine });
              } else {
                var _filterLine2 = { data: [markLineOption] };
                newSeriesData = _.extend({}, seriesData, { markLine: _filterLine2 });
              }
              option.series.splice(index, 1, newSeriesData);
            }
          });
        });
      }

      option.tooltip = {
        trigger: 'axis',
        textStyle: {
          fontSize: 12
        },
        formatter: function formatter(params) {
          if (params.length) {
            var ret = params[0].axisValueLabel;
            var compareTxt = '';
            _.forEach(params, function (chartConfig, index) {
              var seriesName = chartConfig.seriesName;
              var filterSeries = _.find(data.series, function (seriesData) {
                return seriesData.name == seriesName;
              });
              var showType = null;
              var isCompareIncrRatio = false;
              var formatVal = '';
              if (filterSeries) {
                var currentFieldKey = filterSeries.field_key;
                if (widgetChart && widgetChart.l_y_axis && widgetChart.r_y_axis) {
                  if (widgetChart.l_y_axis[currentFieldKey]) {
                    var _widgetChart$l_y_axis = widgetChart.l_y_axis[currentFieldKey],
                        compare = _widgetChart$l_y_axis.compare,
                        show_type = _widgetChart$l_y_axis.show_type;

                    if (compare && compare.field_id && compare.type && compare.value == 'incr_ratio') {
                      isCompareIncrRatio = true;
                    }
                    if (widgetStyle && widgetStyle.l_graph.type == 'percent') {
                      formatVal = chartConfig.value + '%';
                    }
                    showType = show_type;
                  } else if (widgetChart.r_y_axis[currentFieldKey]) {
                    showType = widgetChart.r_y_axis[currentFieldKey].show_type;
                    if (widgetStyle && widgetStyle.r_graph.type == 'percent') {
                      formatVal = chartConfig.value + '%';
                    }
                  }
                }
              }

              if (showType) {
                if (chartConfig.value) {
                  if (!formatVal) {
                    if (isCompareIncrRatio) {
                      formatVal = Func.formatNumByUnitAndThoundth(chartConfig.value, showType.thousandth, '%', 'suffix');
                    } else {
                      formatVal = Func.formatNumByUnitAndThoundth(chartConfig.value, showType.thousandth, showType.unit, showType.compose);
                    }
                  }
                } else {
                  formatVal = showType && showType.null_value === '0' ? '0' : '--';
                }

                if (filterSeries && filterSeries.is_compare_series) {
                  if (data.compare_xAxis && data.compare_xAxis.data) {
                    var compareAxis = data.compare_xAxis.data;
                    if (compareAxis[chartConfig.dataIndex]) {
                      var filterName = compareAxis[chartConfig.dataIndex].value;
                      if (filterName) {
                        if (compareTxt) {
                          compareTxt = compareTxt + '<br/>' + chartConfig.seriesName + '：' + formatVal;
                        } else {
                          compareTxt = filterName + '<br/>' + chartConfig.seriesName + '：' + formatVal;
                        }
                      } else {
                        if (compareTxt) {
                          compareTxt = compareTxt + '<br/>' + chartConfig.seriesName + '：' + formatVal;
                        } else {
                          compareTxt = chartConfig.seriesName + '：' + formatVal;
                        }
                      }
                    }
                  }
                } else {
                  ret = ret + '<br/>' + chartConfig.seriesName + '：' + formatVal;
                }
              }
            });
            if (compareTxt) {
              ret = ret + '<br/>' + compareTxt;
            }
            return ret;
          } else {
            return '';
          }
        }
      };
      break;
    case 'map':
      var minValue = parseInt(data.min_value, 10) || 0;
      var maxValue = parseInt(data.max_value, 10) || 0;

      if (minValue === maxValue) {
        if (minValue < 0 && maxValue < 0) {
          maxValue = 0;
        } else if (minValue > 0 && maxValue > 0) {
          minValue = 0;
        }
      }

      var visualMapData = {
        type: 'continuous',
        min: minValue,
        max: maxValue,
        left: 'left',
        top: 'bottom',
        text: ['高', '低'],
        inRange: { color: THREE_COLORS_GRADIENT[1] },
        calculable: true,
        show: true,
        itemWidth: 20,
        itemHeight: 60
      };

      var label = { show: true };
      if (widgetStyle) {
        var valuesTitle = widgetStyle.values_title,
            lineColor = widgetStyle.color,
            showScale = widgetStyle.show_scale;


        label = {
          show: valuesTitle.is_show
        };

        visualMapData.inRange = { color: lineColor.color };
        visualMapData.show = showScale.is_show;
      }
      option.series[0].label = { normal: label };

      option.visualMap = [visualMapData];

      if (widgetChart && widgetChartValue) {
        option.tooltip = {
          trigger: 'item',
          textStyle: {
            fontSize: 12,
            fontWeight: 'normal'
          },
          formatter: function formatter(params) {
            if (!_.isEmpty(params)) {
              var value = params.value,
                  name = params.name;

              var formatName = name + '<br/>' + data.series[0].name + '\uFF1A';
              var showType = widgetChartValue.show_type;
              var isCompareIncrRatio = false;
              if (widgetChartValue.compare) {
                var _widgetChartValue$com2 = widgetChartValue.compare,
                    field_id = _widgetChartValue$com2.field_id,
                    type = _widgetChartValue$com2.type,
                    _value2 = _widgetChartValue$com2.value;

                if (field_id && type && _value2 == 'incr_ratio') {
                  isCompareIncrRatio = true;
                  var attachedName = _.find(COMPARE_ITEMS, { value: _value2 }).name;
                  formatName = name + '<br/>' + data.series[0].name + '-' + attachedName + '\uFF1A';
                }
              }

              var formatVal = '';
              if (value) {
                if (showType) {
                  if (isCompareIncrRatio) {
                    formatVal = Func.formatNumByUnitAndThoundth(value, showType.thousandth, '%', 'suffix');
                  } else {
                    formatVal = Func.formatNumByUnitAndThoundth(value, showType.thousandth, showType.unit, showType.compose);
                  }
                } else {
                  if (isCompareIncrRatio) {
                    formatVal = value + '%';
                  } else {
                    formatVal = value;
                  }
                }
              } else {
                formatVal = showType && showType.null_value === '0' ? '0' : '--';
              }

              return formatName + formatVal;
            } else {
              return '';
            }
          }
        };
      }
      break;
    case 'table':
    default:
      break;
  }

  var toMerge = {};
  if (widgetChart && widgetChartValue && widgetStyle && widgetStyle.values_title) {
    var _valuesTitle = widgetStyle.values_title;
    var _label = { title: _valuesTitle.title, show: _valuesTitle.is_show, position: _valuesTitle.position };
    var showType = widgetChartValue.show_type;
    var isCompareIncrRatio = false;
    var markPoint = void 0;
    var markLine = void 0;

    if (widgetChartValue.compare) {
      var _widgetChartValue$com3 = widgetChartValue.compare,
          field_id = _widgetChartValue$com3.field_id,
          type = _widgetChartValue$com3.type,
          value = _widgetChartValue$com3.value;

      if (field_id && type && value == 'incr_ratio') {
        isCompareIncrRatio = true;
      }
    }

    switch (_label.show ? _valuesTitle.title : null) {
      case 'dataName':
        _label.formatter = '{b}';
        break;
      case 'dataValue':
        if (showType) {
          _label.formatter = function (params) {
            var value = params.value;

            var formatVal = void 0;
            if (isCompareIncrRatio) {
              formatVal = Func.formatNumByUnitAndThoundth(value, showType.thousandth, '%', 'suffix');
            } else {
              formatVal = Func.formatNumByUnitAndThoundth(value, showType.thousandth, showType.unit, showType.compose);
            }

            return formatVal;
          };
        } else {
          _label.formatter = isCompareIncrRatio ? '{c}%' : '{c}';
        }
        break;
      case 'proportion':
        _label.formatter = '{d}%';
        break;
      case 'nameAndValue':
        if (showType) {
          _label.formatter = function (params) {
            var name = params.name,
                value = params.value;

            var formatVal = void 0;
            if (isCompareIncrRatio) {
              formatVal = Func.formatNumByUnitAndThoundth(value, showType.thousandth, '%', 'suffix');
            } else {
              formatVal = Func.formatNumByUnitAndThoundth(value, showType.thousandth, showType.unit, showType.compose);
            }

            return name + '\uFF1A' + formatVal;
          };
        } else {
          _label.formatter = isCompareIncrRatio ? '{b}：{c}%' : '{b}：{c}';
        }
        break;
      case 'nameAndProportion':
        _label.formatter = '{b}: {d}%';
        break;
      case 'value(proportion)':
        if (showType) {
          _label.formatter = function (params) {
            var percent = params.percent,
                value = params.value;

            var formatVal = void 0;
            if (isCompareIncrRatio) {
              formatVal = Func.formatNumByUnitAndThoundth(value, showType.thousandth, '%', 'suffix') + ('(' + percent + '%)');
            } else {
              formatVal = Func.formatNumByUnitAndThoundth(value, showType.thousandth, showType.unit, showType.compose) + ('(' + percent + '%)');
            }

            return formatVal;
          };
        } else {
          _label.formatter = isCompareIncrRatio ? '{c}%({d}%)' : '{c}({d}%)';
        }
        break;
      case 'nameAndValue(proportion)':
        if (showType) {
          _label.formatter = function (params) {
            var name = params.name,
                percent = params.percent,
                value = params.value;

            var formatVal = void 0;

            if (isCompareIncrRatio) {
              formatVal = name + '\uFF1A' + Func.formatNumByUnitAndThoundth(value, showType.thousandth, '%', 'suffix') + '(' + percent + '%)';
            } else {
              formatVal = name + '\uFF1A' + Func.formatNumByUnitAndThoundth(value, showType.thousandth, showType.unit, showType.compose) + '(' + percent + '%)';
            }

            return formatVal;
          };
        } else {
          _label.formatter = isCompareIncrRatio ? '{b}\uFF1A{c}%({d}%)' : '{b}：{c}({d}%)';
        }
        break;

      case 'nameAndConversionRate':
      case 'conversionRate':
        _label.formatter = function (params) {
          var seriesData = data.series[params.seriesIndex].data;
          var conversionRate = '100%';

          if (params.dataIndex > 0) {
            var prevIndex = params.dataIndex - 1;
            var prevVal = seriesData[prevIndex].value;
            var rateValString = (params.value / prevVal).toString();
            conversionRate = Math.round(parseFloat(rateValString.substr(0, rateValString.indexOf('.') + 3)) * 100) + '%';
          }

          if (_label.title == 'nameAndConversionRate') {
            return params.name + ': ' + conversionRate;
          } else {
            return conversionRate;
          }
        };
        break;
      case 'nameAndArrivalRate':
      case 'arrivalRate':
        _label.formatter = function (params) {
          var startData = data.series[params.seriesIndex].data[0];
          var rateValString = (params.value / startData.value).toString();
          var arrivalRate = Math.round(parseFloat(rateValString.substr(0, rateValString.indexOf('.') + 3)) * 100) + '%';

          if (_label.title == 'nameAndArrivalRate') {
            return params.name + ': ' + arrivalRate;
          } else {
            return arrivalRate;
          }
        };
        break;
    }

    if (!_label.show || _label.formatter) {
      toMerge.label = {
        normal: _label
      };
    }
    if (markPoint) {
      toMerge.markPoint = markPoint;
    }
    if (markLine) {
      toMerge.markLine = markLine;
    }
  }

  if (!_.isEmpty(colors)) {
    option.color = colors;
  }

  if (option.series) {
    option.series = _.map(option.series, function (ds) {
      return _.extend({}, ds, {
        itemStyle: highlight ? {
          normal: _.extend({}, _.get(ds, 'itemStyle.normal', {}), { opacity: 0.3 }),
          emphasis: _.extend({}, _.get(ds, 'itemStyle.emphasis', {}), { opacity: 1 })
        } : _.get(ds, 'itemStyle', {})
      }, toMerge);
    });
  }

  if (_.get(option, 'grid.containLabel') !== false) {
    _.set(option, 'grid.containLabel', true);
  }

  if (false !== _.get(option, 'tooltip.confine')) {
    _.set(option, 'tooltip.confine', true);
  }

  return option;
}
