/*
	Author : MaxCong
	Description : 对editor进行方法包装
	使用方式：
	HB.bold() // 粗体
	HB.italic() //斜体
	HB.ol() //列表
	HB.ul() //列表
	HB.focus() //获取焦点
	HB.blur() //失去焦点
	HB.replaceValue('xxx') //替换内容
	HB.getValue() //获取编辑器内容
	HB.appendValue('xxx') //追加内容
*/

var HB = HB || {};
(function(){

	// 直接在编辑当前光标或选中值上进行加粗操作
	var _bold = function() {
		window.editor.toolbar.findButton('bold').command();
	}

	// 斜体
	var _italic = function() {
		window.editor.toolbar.findButton('italic').command();
	}

	// OrderListButton的方法必须先让编辑器获取焦点
	var _ol = function() {
		window.editor.toolbar.findButton('ol').command();
	}

	// UnorderListButton的方法必须先让编辑器获取焦点
	var _ul = function() {
		window.editor.toolbar.findButton('ul').command();
	}

	// 编辑器获取焦点的方法
	var _focus = function () {
		window.editor.focus();
	}

	var _blur = function () {
		window.editor.blur();
	}

	var _replaceValue = function (content) {
		window.editor.setValue(content);
	}

	var _getValue = function () {
		return window.editor.getValue();
	}

	var _appendValue = function (appendContent) {
		var editorHtml = _getValue();
		var editorHtmlSub = editorHtml.substring(0, editorHtml.length - 4);
		console.log(editorHtmlSub);
		_replaceValue(editorHtmlSub + appendContent + "</p>");
	}

	var _insertText = function (insertContent) {
		window.editor.toolbar.findButton('insert').command(insertContent);
	}

	var _insertAT = function (username, userID) {
		//<a href=\"###\" hb_type=\"user\" user_id=\"5911061\">@xxxx</a>
		window.editor.toolbar.findButton('at').command(username, userID);
	}

	var _insertImage = function (photoID, src) {
		window.editor.toolbar.findButton('hbimage').command(photoID, src);
	}
	
	/** android定制功能 **/
	var _saveContent = function () {
		HB.saveContent(_getValue());
	}
	
	// 对外公开方法
	HB.bold = _bold;
	HB.italic = _italic;
	HB.ol = _ol;
	HB.ul = _ul;
	HB.focus = _focus;
	HB.blur = _blur;
	HB.replaceValue = _replaceValue;
	HB.getValue = _getValue;
	HB.appendValue = _appendValue;
	HB.insertText = _insertText;
	HB.insertAT = _insertAT;
	HB.insertImage = _insertImage;
	
	/** android定制功能  **/
	
	HB.saveConten = _saveContent;
	
	
})();