/** Huoban Common.js
 Author : Abel
 **/

(function () {
    var wk = /webkit\/(\d+)/i.test(navigator.userAgent) && (RegExp.$1 < 525);
    var fn = [];
    var run = function () { for (var i = 0; i < fn.length; i++) fn[i](); };
    var d = document;
    d.ready = function (f) {
        if (!wk && d.addEventListener)
            return d.addEventListener('DOMContentLoaded', f, false);

        if (fn.push(f) > 1) return;
        if (wk)
            var t = setInterval(function () {
                if (/^(loaded|complete)$/.test(d.readyState))
                    clearInterval(t), run();
            }, 0);
    };
})();

// id选择器
function $(id) {
    return document.getElementById(id);
}


// 初始化编辑页面使用
function initEditHuoban() {
    document.ready(function(){
        initCategory();
        initImage();
    });
}

// 初始化页面使用
function initViewHuoban() {
    document.ready(function(){
        window.location.href = "#"+anchor;
        initCategory();
        initImage();
        //initHtmlBottomMargin();
    });
}

//初始化图片
function initImage()
{
    var image_box_node = document.getElementsByName('image_box');
    setTimeout(function() {
               for ( var i=0; i < image_box_node.length; i++ ) {
               var width_node = image_box_node[i].childElementCount * 95 + 30;
               image_box_node[i].style.width = width_node + "px";
    }
    }, 1);
}

//初始化富文本
function initRich() {
    setTimeout(function () {
               var rich_nodes = window.document.getElementsByName('content_rich');
               initText(rich_nodes, true);
               }, 1);
}

//初始化多行文本
function initLarge() {
    setTimeout(function () {
               var large_nodes = window.document.getElementsByName('content_large');
               initText(large_nodes, false);
               }, 1);
}

//初始化文本
function initText(text_nodes, isRich) {
    for (var i = 0; i < text_nodes.length; i++) {
        if (text_nodes[i].offsetHeight >= 130) {
            var icon_right_nodes = text_nodes[i].getElementsByClassName('icon_right');
            if (icon_right_nodes.length > 0) {
                icon_right_nodes[0].style.display = "inherit";
            }
            var mask_nodes = text_nodes[i].getElementsByClassName('mask');
            if (mask_nodes.length > 0) {
                mask_nodes[0].style.display = "inherit";
            }
            var field_id = text_nodes[i].parentNode.getAttribute("id");
            text_nodes[i].parentNode.addEventListener('click', function () {
                                                      if(isRich) {
                                                      textRichOnclickView(field_id)
                                                      } else {
                                                      textLargeOnclickView(field_id)
                                                      }
                                                      
                                                      }, true);
        }
    }
}

function initCategory() {
    if (typeof(categorySelectd) != "undefined") {
        for (var categoryId in categorySelectd) {
            var categorySelectedOptions = categorySelectd[categoryId];
            var categoryUl = $(categoryId);

            var categoryLis = categoryUl.getElementsByTagName('li');
            if(categoryLis.length > 0) {
                for (var i = 0; i < categoryLis.length; i++) {
                    var optionId = categoryLis[i].getAttribute('data-category');
                    for (var selectedI in categorySelectedOptions) {
                        var selectedId = categorySelectedOptions[selectedI];
                        if(optionId == selectedId) {
                            categoryLis[i].className += " selected";
                        }
                    }
                }
            }
        }
    }
}

function showOrHideMore(object_node) {
    var isHide = object_node.getAttribute("isHide");
    var lis = object_node.parentNode.getElementsByTagName("li");
    if(isHide == "false") {
        // 现在隐藏
        for(var i = 6; i < lis.length - 1; i ++) {
            lis[i].setAttribute("style","display:none");
        }
        object_node.setAttribute("isHide","ture");
        object_node.innerHTML = "<span class='file_more'><i>展开更多</i><i class='ficon icon_down'> &#xe66a;</i></span>";
    } else {
        // 现在展开
        for(var i = 6; i < lis.length; i ++) {
            lis[i].setAttribute("style","display:block");
        }

        object_node.setAttribute("isHide","false");
        object_node.innerHTML = "<span class='file_more'><i>收起</i><i class='ficon icon_down'> &#xe66a;</i></span>";
    }
}
/*
 --------------------------------------------------------------------------------------------------------------
 *                              item 查看涉及到的 JS函数
 --------------------------------------------------------------------------------------------------------------
 */
//选择分类
function categoryOnclick(object) {
    var multiple = object.parentNode;

    var oTest = multiple.getElementsByTagName("li");

    var category_id = object.getAttribute("data-category");
    
    if (multiple.getAttribute("data-multiple") != "true") {
        for (var i = 0; i < oTest.length; i++) {
            if(object != oTest[i]) {
                oTest[i].className = "";
            }
        };
    };

    var field_id = multiple.getAttribute("id");
    if (object.className.length == 0) {
        object.className = "selected";
        window.location.href = "huoban://category/modify?field_id="+field_id+"&category_id="+category_id +"&selected=1";
    } else {
        object.className = "";
        window.location.href = "huoban://category/modify?field_id="+field_id+"&category_id="+category_id +"&selected=0";
    };
}

function updateCategory(values) {
    for (var categoryId in values) {
        var categorySelectedOptions = values[categoryId];
        var categoryUl = $(categoryId);
        
        var categoryLis = categoryUl.getElementsByTagName('li');
        if(categoryLis.length > 0) {
            for (var i = 0; i < categoryLis.length; i++) {
                categoryLis[i].className = " ";
                var optionId = categoryLis[i].getAttribute('data-category');
                for (var selectedI in categorySelectedOptions) {
                    var selectedId = categorySelectedOptions[selectedI];
                    if(optionId == selectedId) {
                        categoryLis[i].className += "selected";
                        break;
                    }
                }
            }
        }
    }
}

function subAppView(item_id) {
    window.location.href = "huoban://item/view?item_id=" + item_id;
}

function relatedView(item_id){
    window.location.href = "huoban://item/view?item_id=" + item_id;
}

function embedOnclickView(embed_url) {
    var url_array = embed_url.split("://");
    if(url_array.length > 1) {
        document.location.href = embed_url;
    } else {
        document.location.href = "http://" + embed_url;
    }
}

// 多行文本查看
function textLargeOnclickView(field_id) {
    window.location.href = "huoban://largeText/view?field_id="+field_id;
}

// 富文本查看
function textRichOnclickView(field_id) {
    window.location.href = "huoban://richText/view?field_id="+field_id;
}

// 通讯录查看
function contactOnclickView(field_id) {
    window.location.href = "huoban://contact/view?field_id="+field_id;
}

// 文件查看
function fileOnclickView(file_id) {
    window.location.href = "huoban://file/download?file_id=" + file_id;
    window.event.cancelBubble = true;
}

function userOnclickView(user_id) {
    window.location.href = "huoban://user/view?user_id="+user_id;
}

function commentReply(commentId,user_id) {
    window.location.href = "#comment_"+commentId;
    window.location.href = "huoban://comment/reply?commentId="+ commentId+"&user_id="+user_id;
}

function imageOnclickView(field_id,file_id) {
    window.location.href = "huoban://image/view?field_id="+field_id+"&file_id="+file_id;
}

/*
 --------------------------------------------------------------------------------------------------------------
 *                              item 修改时涉及到的 openURL 说明
 --------------------------------------------------------------------------------------------------------------
 */

// 单文本编辑
function modifyTextSmallOnclick(field_id) {
    window.location.href = "huoban://smallText/modify?field_id="+field_id;
}

// 多行文本编辑
function modifyTextLargeOnclick(field_id) {
    window.location.href = "huoban://largeText/modify?field_id="+field_id;
}

// 富文本编辑
function modifyTextRichOnclick(field_id) {
    window.location.href = "huoban://richText/modify?field_id="+field_id;
}

// 数字编辑
function modifyNumberOnclick(field_id) {
    window.location.href = "huoban://number/modify?field_id="+field_id;
}

// 链接编辑
function modifyEmbedOnclick(field_id) {
    window.location.href = "huoban://embed/modify?field_id="+field_id;
}

// 类别编辑
function modifyCategoryOnclick(field_id) {
    window.location.href = "huoban://category/modify?field_id="+field_id;
}

// 通讯录编辑
function modifyContactOnclick(field_id) {
    window.location.href = "huoban://contact/modify?field_id="+field_id;
}

// 图片编辑
function modifyImageOnclick(field_id) {
    window.location.href = "huoban://image/modify?field_id="+field_id;
}

// 弹出日期编辑(原窗口弹选择器)
function modifyDatePopup(field_id,is_start,is_date) {
    window.location.href = "huoban://date/modify?is_pop=1&field_id="+field_id+"&is_start="+is_start+"&is_date="+is_date;
}

// 修改日期(创建新窗口)
function modifyDateOnclick(field_id) {
    window.location.href = "huoban://date/modify?field_id="+field_id;
}

// 编辑文件
function modifyFileOnclick(field_id) {
    window.location.href = "huoban://file/modify?field_id="+field_id;
}

// 编辑子表
function modifySubAppOnclick(field_id) {
    window.location.href = "huoban://sublist/modify?field_id="+field_id;
}

// 编辑关联数据
function modifyRelatedItemOnclick(field_id) {
    window.location.href = "huoban://relationship/modify?field_id="+field_id;
}

// 删除文件
function deleteFile(field_id,file_id){
    var li_object = $(field_id+"&"+file_id);
    li_object.parentNode.removeChild(li_object);
    window.location.href = "huoban://file/delete?field_id="+field_id+"&file_id="+file_id;
}

// 删除关联
function deleteRelatedItem(field_id,item_id) {
    var related_item_Node = $(field_id+"&"+item_id);
    related_item_Node.parentNode.removeChild(related_item_Node);
    window.location.href = "huoban://relationship/delete?field_id=" + field_id +"&item_id="+item_id;
}

function deleteUser(field_id, user_id) {
    window.location.href = "huoban://user/delete?field_id=" + field_id +"&user_id="+user_id;
}

// 添加子表
function addSubApp(field_id) {
    window.location.href = "huoban://sublist/add?field_id=" + field_id;
}

// 添加关联
function addRelationship(field_id) {
    window.location.href = "huoban://relationship/add?field_id=" + field_id;
}

/*
 --------------------------------------------------------------------------------------------------------------
 *
 *                                      webView使用js接口
 *
 --------------------------------------------------------------------------------------------------------------
 */
// 更新日期
function updateDate(date_string,field_id,is_start,is_date) {
    if (is_start == "1") {
        if (is_date == "1") {
            var date_node = $(field_id+"_date_start");
            date_node.innerHTML = date_string;
        } else {
            var date_node = $(field_id+"_time_start");
            date_node.innerHTML = date_string;
        };
    } else {
        if (is_date == "1") {
            var date_node = $(field_id+"_date_end");
            date_node.innerHTML = date_string;
        } else {
            var date_node = $(field_id+"_time_end");
            date_node.innerHTML = date_string;
        };
    };
}

// 更新文本
function updateText(field_id,content) {
    var div_node = $(field_id);
    div_node.setAttribute("class","content_rich content_text");
    div_node.innerHTML = content;
}

// 更新数字
function updateNumber(field_id,content) {
    var div_node = $(field_id);
    div_node.setAttribute("class","content content_text");
    div_node.innerHTML = content;
}

// 更新链接
function updateEmbed(field_id,content) {
    var div_node = $(field_id);
    div_node.setAttribute("class","content content_text text_line");
    div_node.innerHTML = content;
}

// 添加评论
function appendNewComment(commentId,user_id,user_name,user_avatar_url,reply_userName,content,created_on)
{
    var commentNone = $("commentNone");
    if(commentNone) {
        commentNone.parentNode.removeChild(commentNone);
    }
    var comments = $("comments");
    if (comments == undefined) {
        var newNode = document.createElement("div");
        newNode.setAttribute("id", "comments");
        newNode.innerHTML = "<div id='comments' class='item_box'><hr class='line_top' /><h4 class='item_title'><i class='ficon title_icon' >&#xe609;</i><i class='title_name' >评论</i><hr class='title_line' /></h4><div class='comment_box'><ul id='comment_box'></ul></div><hr class='line_bottom'/></div>";
        document.body.appendChild(newNode);
    };
    var newNode = document.createElement("div");
    newNode.setAttribute("class", "comment cl");
    newNode.setAttribute("onclick", "commentReply("+ commentId +","+user_id+")");
    
    if(reply_userName == "") {
        var childNode = "<li class='comment_li' onclick='commentReply('"+ commentId +"','"+ user_id +"'><div class='comment_info'><img class='created_photo' src='"+user_avatar_url+"' /><i class='timeline'>"+ created_on +"</i><span class='comment_author_span'><i class='comment_author'>"+user_name+"</i></span></div><div class='comment_text'>"+content+"</div></li>";
        newNode.innerHTML = childNode;
    } else {
        var childNode = "<li class='comment_li' onclick='commentReply('"+ commentId +"','"+ user_id +"'><div class='comment_info'><img class='created_photo' src='"+user_avatar_url+"' /><i class='timeline'>"+ created_on +"</i><span class='comment_author_span'><i class='comment_author'>"+user_name+"</i><i class='comment_reply'>回复</i><i class='comment_author'>"+ reply_userName +"</i></span></div><div class='comment_text'>"+content+"</div></li>";
        newNode.innerHTML = childNode;
    }
    
    
    
    var comment_node = $("comment_box");
    
    if (comment_node.hasChildNodes)
        comment_node.insertBefore(newNode, comment_node.firstChild);
    else
        comment_node.appendChild(newNode);
}

// 移除loading
function removeLoadComment()
{
    var laoding_node = $("comment_loading");
    laoding_node.parentNode.removeChild(laoding_node);
}

// 追加loading
function appendLoadComment()
{
    var comment_node = $("comments");
    if (comment_node == undefined) {
        var newNode = document.createElement("div");
        newNode.setAttribute("id", "comments");
        newNode.innerHTML = "<div id='comments' class='item_box'><hr class='line_top' /><h4 class='item_title'><i class='ficon title_icon' >&#xe609;</i><i class='title_name' >评论</i><hr class='title_line' /></h4><div class='comment_box'><ul id='comment_box'></ul></div><hr class='line_bottom'/></div>";
        document.body.appendChild(newNode);
    };

    var ul_node = $("comment_box").parentNode;
    var comment_loading = $("comment_loading");
    if (comment_loading == undefined) {
        comment_loading = document.createElement("div");
        comment_loading.setAttribute("id","comment_loading");
        comment_loading.setAttribute("calss","comment_loading");
        comment_loading.innerHTML = "<i class='load_icon'></i><i class='load_content'>加载中...</i>";
        ul_node.appendChild(comment_loading);
    };
}

// 增加关联
function appendRelationship(field_id,app_name,item_name,item_id,user_name,created_on) {
    var add_li_node = $(field_id);
    var newNode = document.createElement("li");
    newNode.setAttribute("id", field_id+"&"+item_id);
    var childNode = "<i class='ficon icon_right' onclick=\"deleteRelatedItem('"+field_id+"','"+ item_id +"')\">&#xe699;</i><p class='apptitle'>"+ item_name +" - "+ app_name +"</p><p class='appinfo'><i class='app_user'>" + user_name +"</i><i>"+ created_on +"</i></p>";
    newNode.innerHTML = childNode;
    add_li_node.parentNode.insertBefore(newNode,add_li_node);
}

// 删除关联数据
function deleteRelationshipByFieldIDAndItemID(field_id,item_id)
{
    var li_Node = $(field_id+"&"+item_id);
    li_Node.parentNode.removeChild(li_Node);
}

// 添加图片
function appendImage(field_id,file_id,file_url) {
    var ul_node = $(field_id);
    var li_nodes = ul_node.getElementsByTagName("li");
    if(li_nodes.length == 0){
        ul_node.innerHTML = "";
        ul_node.parentNode.setAttribute("class","content cl image_scroll");
    }
    var newNode = document.createElement("li");
    newNode.setAttribute("id", field_id+"&"+file_id);
    var childNode = "<img src='"+file_url+"'/>";
    newNode.innerHTML = childNode;
    ul_node.appendChild(newNode);

    var width_node = ul_node.childElementCount * 95 + 30;
    ul_node.style.width = width_node + "px";
}


// 删除图片
function deleteImage(field_id,image_id) {
    var li_Node = $(field_id+"&"+image_id);
    li_Node.parentNode.removeChild(li_Node);
    var width_node = ul_node.childElementCount * 95 + 30;
    ul_node.style.width = width_node + "px";
}

// 添加联系人
function appendContact(field_id,user_id,avatar_url) {
    var add_li_node = $(field_id);
    var newNode = document.createElement("li");
    newNode.setAttribute("id", field_id+"&"+user_id);
    var childNode = "<img class='contact_photo' src='"+avatar_url+"'/>";
    newNode.innerHTML = childNode;
    add_li_node.parentNode.insertBefore(newNode,add_li_node);
}

// 删除联系人
function deleteContact(field_id,user_id) {
    var li_Node = $(field_id + "&" + user_id);
    li_Node.parentNode.removeChild(li_Node);
}

function addCommentToBoxAffter(commentHtml) {
    commentHtml = commentHtml.replace(new RegExp("%5C%5C", "g"), "\\").replace(new RegExp("&#39;", "g"), "'").replace(new RegExp("&#00;", "g"), "%27").replace(new RegExp("&#01;", "g"), "%25").replace(new RegExp("&#02;", "g"), "%2B").replace(new RegExp("&#03;", "g"), "%2F");
    $("comment_box").innerHTML = $("comment_box").innerHTML + commentHtml;
}

function commentNone()
{
    $("comment_box").innerHTML = "<div class='content_none' id='commentNone'>暂无评论</div>";
}

function updateContent(contentHtml) {
    $("content_box").innerHTML = contentHtml;
}

function updateInfo(infoHtml) {
    $("info_box").innerHTML = infoHtml;
}

/*
 --------------------------------------------------------------------------------------------------------------
 *                              item 修改时涉及到的 openURL 说明
 --------------------------------------------------------------------------------------------------------------
 *
 *   1. 修改日期
 *       huoban://date/modify?field_id={{field_id}}&is_start={{0 or 1}}&is_date={{0 or 1}}
 *   2. 添加文件
 *       huoban://file/add?field_id={{field_id}}
 *   3. 添加图片
 *       huoban://image/add?field_id={{field_id}}
 *   4. 添加联系人
 *       huoban://contact/add?field_id={{field_id}}
 *   5. 删除文件
 *       huoban://file/delete?field_id={{field_id}}&id={{file_id}}
 *   6. 删除图片
 *       huoban://image/delete?field_id={{field_id}}&id={{file_id}}
 *   7. 删除通讯录
 *       huoban://image/delete?field_id={{field_id}}&id={{contact_id}}
 *   8. 修改类别
 *       huoban://category/modify?field_id={{field_id}}&category_id={{category_id}}&selected={{is_selected}}
 *   9. 修改文本
 *       huoban://text/modify?field_id={{field_id}}&type={{type}}
 --------------------------------------------------------------------------------------------------------------
 */